﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ThesisSudokuPham
{
    public partial class Form1 : Form
    {
        //---------------------------------------------------------------------------
        // ->Cells[Spaltennummer][Zeilennummer]

        // Kopie des Progamms aus Kaiser S. 341 oder pdf S. 356
        //double GetHRFrequency()
        //{ // Der Funktionswert ist die Auflösung des HR-Timers
        //    //LARGE_INTEGER f;
        //    long f;
        //    bool bf = QueryPerformanceFrequency(f);
        //    if (bf) return f.QuadPart;
        //    else return (-1);
        //}
        //double HRFrequency = GetHRFrequency();
        //double HRTimeInSec()
        //{ // Der Funktionswert ist der aktuelle Wert des
        //    // HR-Timers in Sekunden
        //    long c;
        //    bool bc = QueryPerformanceCounter(&c);
        //    if (bc) return c.QuadPart / HRFrequency;
        //    else return (-1);
        //}
        // Ende Kopie Kaiser
        bool[] moeglich = new bool[9];
        //int Zeileselect, Spalteselect;

        int[,] SG1 = new int[9, 9];
        int[,] SG4 = new int[9, 9];
        String[] ZZ = new String[9];
        String[] Lz = new String[9];
        
        int reccnt = 0;
        int Start = 0;
        int maxident;
        int erg;  //Ergebnis bei Sudokuvergleich, Durchläufe 

        bool possifertig = false;  // wenn iterative Suche mit Taste "Freie Zahlen" fertig
        
        //TStringList *sdkSL = new TStringList();  // Zwischenspeicher für DB- Zeile
        //TStringList *Orte =new TStringList();  // Hier werden die Fundorte gespeichert
        List<string> Orte = new List<string>();
        List<string> SL1 = new List<string>();
        List<string> SL2 = new List<string>();
        //---------------------------------------------------------------------------

        public Form1()
        {
            InitializeComponent();
           // MessageBox.Show("Sudoku Assitent", "Intro", MessageBoxButtons.OK, MessageBoxIcon.Information);
            adRow();                                //Add Rows for Datagridwiew Sudoku Table
            
            
            
        }
        //---------------------------------------------------------------------------
        private void adRow()                         //Add Rows for Datagridwiew Sudoku Table
        {
            dataGridView1.Rows.Add(9);
            for (int i = 0; i < 9; i++)
            {

                DataGridViewRow Rowsheight = dataGridView1.Rows[i];
                Rowsheight.Height = 278 / 9;

            }
            dataGridView2.Rows.Add(9);
            for (int i = 0; i < 9; i++)
            {

                DataGridViewRow Rowsheight = dataGridView2.Rows[i];
                Rowsheight.Height = 278 / 9;

            }
            dataGridView3.Rows.Add(9);
            for (int i = 0; i < 9; i++)
            {

                DataGridViewRow Rowsheight = dataGridView3.Rows[i];
                Rowsheight.Height = 278 / 9;

            }
            dataGridView4.Rows.Add(9);
            for (int i = 0; i < 9; i++)
            {

                DataGridViewRow Rowsheight = dataGridView4.Rows[i];
                Rowsheight.Height = 278 / 9;
            }
            dataGridView5.Rows.Add(9);
            dataGridView6.Rows.Add(9);
            for (int i = 0; i < 9; i++)
            {

                DataGridViewRow Rowsheight = dataGridView6.Rows[i];
                Rowsheight.Height = 278 / 9;
            }
            //dataGridViewDB.Rows.Add(300);

        }

        //---------------------------------------------------------------------------
        private void fill()
        {
            ZZ[0] = "Z1"; ZZ[1] = "Z2"; ZZ[2] = "Z3"; ZZ[3] = "Z4"; ZZ[4] = "Z5"; ZZ[5] = "Z6"; ZZ[6] = "Z7";
            ZZ[7] = "Z8"; ZZ[8] = "Z9";
            Lz[0] = "Lz1"; Lz[1] = "Lz2"; Lz[2] = "Lz3"; Lz[3] = "Lz4"; Lz[4] = "Lz5"; Lz[5] = "Lz6"; Lz[6] = "Lz7";
            Lz[7] = "Lz8"; Lz[8] = "Lz9";
        }

        //---------------------------------------------------------------------------

        void init()
        {
            for (int i = 0; i < 9; i++)
                moeglich[i] = true;
        }


        //---------------------------------------------------------------------------
        private void preload(object sender, EventArgs e)
        {
            labfehler.Visible = false;
            labzsp.Visible = false;

            //btnDB2sdk_Click(sender, e);

            //btnClean_Click(sender, e);

            //btnCopyd_Click(sender, e);
        }

        private void dgvPaint()
        {
            Graphics e = dataGridView1.CreateGraphics();
            
            Pen p = new Pen(Color.Black, 2);
            Point poi1 = new Point(0, 92);
            Point poi2 = new Point(278, 92);
            e.DrawLine(p, poi1, poi2);
            Point poi3 = new Point(0, 183);
            Point poi4 = new Point(278, 183);
            e.DrawLine(p, poi3, poi4);
            Point poi5 = new Point(92, 0);
            Point poi6 = new Point(92, 278);
            e.DrawLine(p, poi5, poi6);
            Point poi7 = new Point(183, 0);
            Point poi8 = new Point(183, 278);
            e.DrawLine(p, poi7, poi8);

        }
        
        private void dataGridView1_Paint(object sender, PaintEventArgs e)
        {
            dgvPaint();
        }

        private void dataGridView3_Paint(object sender, PaintEventArgs e)
        {
            Pen p = new Pen(Color.Black, 2);
            Point poi1 = new Point(0, 92);
            Point poi2 = new Point(278, 92);
            e.Graphics.DrawLine(p, poi1, poi2);
            Point poi3 = new Point(0, 183);
            Point poi4 = new Point(278, 183);
            e.Graphics.DrawLine(p, poi3, poi4);
            Point poi5 = new Point(92, 0);
            Point poi6 = new Point(92, 278);
            e.Graphics.DrawLine(p, poi5, poi6);
            Point poi7 = new Point(183, 0);
            Point poi8 = new Point(183, 278);
            e.Graphics.DrawLine(p, poi7, poi8);
        }

        private void dataGridView2_Paint(object sender, PaintEventArgs e)
        {
            Pen p = new Pen(Color.Black, 2);
            Point poi1 = new Point(0, 92);
            Point poi2 = new Point(556, 92);
            e.Graphics.DrawLine(p, poi1, poi2);
            Point poi3 = new Point(0, 183);
            Point poi4 = new Point(556, 183);
            e.Graphics.DrawLine(p, poi3, poi4);
            Point poi5 = new Point(182, 0);
            Point poi6 = new Point(182, 278);
            e.Graphics.DrawLine(p, poi5, poi6);
            Point poi7 = new Point(361, 0);
            Point poi8 = new Point(361, 278);
            e.Graphics.DrawLine(p, poi7, poi8);
        }
        private void loadsdk()
        {
            labfehler.Visible = false;
            labzsp.Visible = false;
            
            
            string text = "WAMS 2 mittel.sdk";
            openFileDialog4.FileName = text;

            StreamReader myStream = new StreamReader(text, Encoding.Default);

            Memo1.Text = myStream.ReadToEnd();
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {

                    dataGridView1.Rows[i].Cells[j].Value = Memo1.Lines[i + 1].ToString().Substring(j, 1);
                    dataGridView2.Rows[i].Cells[j].Value = Memo1.Lines[i + 1].ToString().Substring(j, 1);
                    dataGridView3.Rows[i].Cells[j].Value = Memo1.Lines[i + 1].ToString().Substring(j, 1);

                }
            myStream.Close();
            label1.Text = Memo1.Lines[0].ToString();
        }
        private void Form1_Activated(object sender, EventArgs e)
        {
            if (Start == 0)
            {
                //FormIntro->ShowModal();
                fill();
                //Tablesdk->Active = true;

                preload(sender, e);
                //Tablesdk->Last();
            }


            Start++;
            loadsdk();
            btnClean_Click(sender, e);
            //reccnt = Tablesdk->RecordCount;//FieldByName("NR")->AsInteger;
            //LabelActsdk->Caption = "Aktuell " + IntToStr(reccnt) + " Sudokus";
        }

        //---------------------------------------------------------------------------
        bool check(int a, int b)  // Prüft bei vorhandener Zahl Sudokobedingung
        {
            String s;
            int zahlab, zahl, i, j;
            if (dataGridView1.Rows[a].Cells[b].Value != null)
            {
                s = dataGridView1.Rows[a].Cells[b].Value.ToString();
                if (s == "") return (true);   //Wenn Feld leer, nix zu prüfen
                zahlab = Convert.ToInt32(s);

                for (i = 0; i < 9; i++)    // Vergleiche in Spalte
                {
                    if (dataGridView1.Rows[a].Cells[i].Value != null)
                    {
                        s = dataGridView1.Rows[a].Cells[i].Value.ToString();
                        if (!(s == "") & (i != b))
                        {
                            zahl = Convert.ToInt32(s);
                            if (zahl == zahlab)
                                return (false);
                        }
                    }
                }
                for (i = 0; i < 9; i++)    // Vergleiche in Zeile
                {
                    if (dataGridView1.Rows[i].Cells[b].Value != null)
                    {
                        s = dataGridView1.Rows[i].Cells[b].Value.ToString();
                        if (!(s == "") & (i != a))
                        {
                            zahl = Convert.ToInt32(s);
                            if (zahl == zahlab)
                                return (false);
                        }
                    }
                }
                int h = a / 3, v = b / 3;      // Suche in Unter- 3*3 Feld
                for (i = h * 3; i < h * 3 + 3; i++)
                    for (j = v * 3; j < v * 3 + 3; j++)
                    {
                        if (dataGridView1.Rows[i].Cells[j].Value != null)
                        {
                            s = dataGridView1.Rows[i].Cells[j].Value.ToString();
                            if (!(s == "") & (i != a) & (j != a))
                            {
                                zahl = Convert.ToInt32(s);
                                if (zahl == zahlab)
                                    return (false);
                            }
                        }
                    }
            }
            else dataGridView1.Rows[a].Cells[b].Value = "";
            return (true);

        }

        private void btnCheck_Click(object sender, EventArgs e)
        {
           
            labfehler.Visible = false;
            labzsp.Visible = false;


            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (!check(i, j))
                    {
                        labfehler.Visible = true;
                        labzsp.Visible = true;
                        labfehler.Text = "Double Number in Row." + Convert.ToString(i + 1)
                            + ", Col." + Convert.ToString(j + 1) + " won't work!";
                        labzsp.Text = "Check last Number: Row." + Convert.ToString(dataGridView1.CurrentCell.RowIndex + 1)
                            + ",Col. " + Convert.ToString(dataGridView1.CurrentCell.ColumnIndex + 1);
                        var rec = dataGridView1.GetCellDisplayRectangle(j, i, false);
                        Graphics data1 = Graphics.FromHwnd(dataGridView1.Handle);
                        Pen pen1 = new Pen(Color.Red, 1);
                        data1.DrawRectangle(pen1, rec);

                        i = 9; j = 9;  // Ende der forschleifen

                    }
                    //if (dataGridView3.Rows[i].Cells[j].Value.ToString() != "")
                    //    if (dataGridView3.Rows[i].Cells[j].Value != dataGridView1.Rows[i].Cells[j].Value)
                    //    {  // Aufgabe in SG3 passt nicht zu SG1 !!
                    //        var rec = dataGridView3.GetCellDisplayRectangle(j, i, false);
                    //        Graphics data1 = Graphics.FromHwnd(dataGridView3.Handle);
                    //        Pen pen1 = new Pen(Color.Red, 1);
                    //        data1.DrawRectangle(pen1, rec);
                    //    }


                };
            if (!labzsp.Visible) btnClean_Click(sender, e);
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
           
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                labfehler.Visible = false;
                labzsp.Visible = false;
                Memo1.Clear();
                btnClr_Click(sender, e);
                
                
                StreamReader myStream = new StreamReader(openFileDialog1.FileName, Encoding.Default);
                Memo1.Text = myStream.ReadToEnd();
                for (int i = 0; i < 9; i++)
                    for (int j = 0; j < 9; j++)
                    {

                        dataGridView1.Rows[i].Cells[j].Value = Memo1.Lines[i + 1].ToString().Substring(j, 1);
                        dataGridView2.Rows[i].Cells[j].Value = Memo1.Lines[i + 1].ToString().Substring(j, 1);
                        dataGridView3.Rows[i].Cells[j].Value = Memo1.Lines[i + 1].ToString().Substring(j, 1);

                    }
                myStream.Close();
                
            }
            btnClean_Click(sender, e);
            label1.Text = Memo1.Lines[0].ToString();
            listBox4.Items.Clear();
            
        }

        private void btnClean_Click(object sender, EventArgs e)
        {
            clean();
            String a;
            char b;

            for (int i = 0; i < 9; i++)  // alle Zeichen außer 1-9 durch Leerstring ersetzen
                for (int j = 0; j < 9; j++)
                {
                    a = dataGridView1.Rows[i].Cells[j].Value.ToString();
                    if (a.Length > 0)
                    {
                        
                        a = a.Substring(0, 1);
                        b = Convert.ToChar(a);
                        if ((b < '1') | (b > '9')) a = "";
                        if (a == " ") a = "";
                        dataGridView1.Rows[i].Cells[j].Value = a;
                    }
                    // dito mit SG3
                    a = dataGridView3.Rows[i].Cells[j].Value.ToString();
                    if (a.Length > 0)
                    {
                        a = a.Substring(0, 1);
                        b = Convert.ToChar(a);
                        if ((b < '1') | (b > '9')) a = "";
                        if (a == " ") a = "";
                        dataGridView3.Rows[i].Cells[j].Value = a;
                    }

                }
            //BitBtnSave->SetFocus();
        }

        private void btnCopyd_Click(object sender, EventArgs e)
        {
            //PageControl1->ActivePage=TabSheetComp; Dann geht taste "Compare von -- bis schief
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {

                    dataGridView4.Rows[i].Cells[j].Value = dataGridView1.Rows[i].Cells[j].Value;
                    dataGridView2.Rows[i].Cells[j].Value = dataGridView1.Rows[i].Cells[j].Value;
                }

            label5.Text = label1.Text;
        }
        //---------------------------------------------------------------------------
        private String frei(int a, int b)
        {
            init();
            String s;
            int zahl, i, j;
            if  (dataGridView1.Rows[a].Cells[b].Value != null)
            {
                s = dataGridView1.Rows[a].Cells[b].Value.ToString();

                if (!(s == "")) return (s);
            }
                for (i = 0; i < 9; i++)    // Suche in Spalte
                {
                    if  (dataGridView1.Rows[a].Cells[i].Value != null)
                    {
                        s = dataGridView1.Rows[a].Cells[i].Value.ToString();
                        if (!(s == ""))
                        {
                            zahl = Convert.ToInt32(s) - 1;
                            moeglich[zahl] = false;
                        }
                    }
                }
                for (i = 0; i < 9; i++)    // Suche in Zeile 
                {
                    if  (dataGridView1.Rows[i].Cells[b].Value != null)
                    {
                        s = dataGridView1.Rows[i].Cells[b].Value.ToString();
                        if (!(s == ""))
                        {
                            zahl = Convert.ToInt32(s) - 1;
                            moeglich[zahl] = false;
                        }
                    }
                }
                int h = a / 3, v = b / 3;      // Suche in Unter- 3*3 Feld
                for (i = h * 3; i < h * 3 + 3; i++)
                    for (j = v * 3; j < v * 3 + 3; j++)
                    {
                        if  (dataGridView1.Rows[i].Cells[j].Value != null)
                        {
                            s = dataGridView1.Rows[i].Cells[j].Value.ToString();
                            if (!(s == ""))
                            {
                                zahl = Convert.ToInt32(s) - 1;
                                moeglich[zahl] = false;
                            }
                        }
                    }
                 
                s = "";
                for (i = 0; i < 9; i++)
                    if (moeglich[i]) s = s + Convert.ToInt32(i + 1);
                return (s);
            
           
        }

        //---------------------------------------------------------------------------
        bool lsg = false;

        private void btnpossi_Click(object sender, EventArgs e)
        {
            String a;
            bool fehler = false;
            int cntlsg = 0, loop = 0; ;
            do
            {
                
                loop++;
                lsg = false;
                for (int i = 0; i < 9; i++)
                    for (int j = 0; j < 9; j++)
                    {
                        a = frei(i, j);
                        dataGridView2.Rows[i].Cells[j].Value = a;
                        //dataGridView2.Rows[i].Cells[j].Style.Font = fontDialog2.Font;
                        if  (dataGridView1.Rows[i].Cells[j].Value != null)
                        {
                            if (a.Length >= 2)
                            {
                                dataGridView2.Rows[i].Cells[j].Style.Font = fontDialog2.Font;
                            }
                            if ((a.Length == 1) & (dataGridView1.Rows[i].Cells[j].Value == ""))
                            //|| (dataGridView1.Rows[i].Cells[j].Value == null)))
                            {  // Neue Lösung gefunden
                                
                                
                                dataGridView1.Rows[i].Cells[j].Value = a;
                                dataGridView2.Rows[i].Cells[j].Style.Font = fontDialog1.Font;
                                lsg = true;
                                cntlsg++;
                            }
                            if (a.Length == 0)
                            {
                                labfehler.Visible = true;
                                labzsp.Visible = true;
                                labfehler.Text = "No free Number in Row." + Convert.ToString(i + 1) + ", Col." + Convert.ToString(j + 1) + " won't work!";
                                labzsp.Text = "Check last Number: Row." + Convert.ToString(dataGridView1.CurrentCell.RowIndex + 1)
                                + ",Sp. " + Convert.ToString(dataGridView1.CurrentCell.ColumnIndex + 1);
                                var rec = dataGridView1.GetCellDisplayRectangle(j, i, false);
                                Graphics data1 = Graphics.FromHwnd(dataGridView1.Handle);
                                Pen pen1 = new Pen(Color.Red, 1);
                                data1.DrawRectangle(pen1, rec);
                                fehler = true;  // keine Lösung möglich
                                i = 9; j = 9;  // Ende der forschleifen  
                            }
                        }
                        else dataGridView1.Rows[i].Cells[j].Value = ""; 
                    }
            } while ((lsg) && (CBIterativ.Checked));
            if ((!lsg) && (!fehler)) possifertig = true; else possifertig = false;
            if (possifertig) label123.Text = "OK"; else label123.Text = "NotOK";
            if (CBProto.Checked) listBox4.Items.Add("1:  DL= " + Convert.ToString(loop) 
                + "  Lsg= " + Convert.ToString(cntlsg));

        }
        //---------------------------------------------------------------------------

        int[] cnter = new int[9];
        
        void initcnt()
        {
             for (int i=0;i<9;i++) cnter[i]=0;
        }

        
        //---------------------------------------------------------------------------
        bool CheckObEineLsg( ref int lsg)
        { // Modul checkt, ob eine Zahl in den Möglichkeiten nur einmal vorkommt--> Lösung
            bool N1Mlsg = false;
            int i, j, k, zahl, j1;
            String s, alt, tmp;
            lsg = 0;
            Orte.Clear();

            initcnt();
            for (i = 0; i < 9; i++)    // Suche in Spalte
            {
                tmp = "";
                for (j = 0; j < 9; j++)    // Hole jedes Element
                {
                    s = dataGridView2.Rows[i].Cells[j].Value.ToString();
                    if (!(s == "") & !(s.Length == 1))
                    {
                        for (k = 0; k < s.Length; k++)
                        {
                            zahl = Convert.ToInt32(s.Substring(k, 1)) -1;
                            cnter[zahl]++; // in cnter steht, wie oft jede Zahl pro Z / SP vorkommt
                        }
                    }
                }
                // Jetzt reagieren auf Zählerstand 1
                for (j = 0; j < 9; j++)
                    if (cnter[j] == 1)  // wenn Zahl genau nur einmal vorkommt-->Lösung
                    { //Feld mit dieser Lösungszahl suchen
                        zahl = j + 1; //Diese Zahl kommt nur einmal in Z /sp vor
                        for (j1 = 0; j1 < 9; j1++)   //In welchem Feld steht sie?
                        {
                            s = dataGridView2.Rows[i].Cells[j1].Value.ToString();
                            for (k = 0; k < s.Length; k++)
                            {
                                if (zahl == Convert.ToInt32(s.Substring(k, 1)))
                                {
                                    if (dataGridView1.Rows[i].Cells[j1].Value != null)
                                    {
                                        alt = dataGridView1.Rows[i].Cells[j1].Value.ToString();
                                        if (alt.Length == 0) lsg++;
                                        tmp = Convert.ToString(i) + Convert.ToString(j1) + " " + Convert.ToString(zahl);
                                        Orte.Add(tmp + " just 1 time in S");
                                        if (CBuebernehm.Checked)
                                            dataGridView1.Rows[i].Cells[j1].Value = zahl;  //Lösung
                                        dataGridView2.Rows[i].Cells[j1].Style.Font = fontDialog1.Font;
                                        N1Mlsg = true;
                                        j1 = 9; //Suche für diese Zahl beenden
                                    }
                                }
                            }
                        }
                    }
                initcnt();  // Für nächste Spalte neu Zählen
            } //Spalten fertig for i ...

            //  Dat janze noch mal in den Zeilen prüfen

            for (i = 0; i < 9; i++)    // Suche in Zeile
            {
                tmp = "";
                for (j = 0; j < 9; j++)    // Hole jedes Element
                {
                    s = dataGridView2.Rows[j].Cells[i].Value.ToString();
                    if (!(s == "") & !(s.Length == 1))
                    {
                        for (k = 0; k < s.Length; k++)
                        {
                            zahl = Convert.ToInt32(s.Substring(k, 1)) -1;
                            cnter[zahl]++; // in cnter steht, wie oft jede Zahl pro Z / SP vorkommt
                        }
                    }
                }
                // Jetzt reagieren auf Zählerstand 1
                for (j = 0; j < 9; j++)
                    if (cnter[j] == 1)  // wenn Zahl genau nur einmal vorkommt-->Lösung
                    { //Feld mit dieser Lösungszahl suchen
                        zahl = j + 1; //Diese Zahl kommt nur einmal in Z /sp vor
                        for (j1 = 0; j1 < 9; j1++)   //In welchem Feld steht sie?
                        {
                            s = dataGridView2.Rows[j1].Cells[i].Value.ToString();
                            for (k = 0; k < s.Length; k++)
                            {
                                if (zahl == Convert.ToInt32(s.Substring(k, 1)))
                                {
                                    if (dataGridView1.Rows[j1].Cells[i].Value != null)
                                    {
                                        alt = dataGridView1.Rows[j1].Cells[i].Value.ToString();
                                        if (alt.Length == 0) lsg++;
                                        tmp = Convert.ToString(j1) + Convert.ToString(i) + " " + Convert.ToString(zahl);
                                        Orte.Add(tmp + " just 1 time in Z");
                                        if (CBuebernehm.Checked)
                                            dataGridView1.Rows[j1].Cells[i].Value = zahl;  //Lösung
                                        dataGridView2.Rows[j1].Cells[i].Style.Font = fontDialog1.Font;
                                        N1Mlsg = true;
                                        j1 = 9; //Suche für diese Zahl beenden
                                    }
                                }
                            }
                        }
                    }
                initcnt();  // Für nächste Zeile neu Zählen
            } //Zeilen fertig for i ...

            //  Dat janze noch mal in den 3*3 Quadraten prüfen
            int h, v;
            for (h = 0; h < 3; h++)  // h und v sind die Nummern der 3*3 Quadrate
                for (v = 0; v < 3; v++)
                {
                    tmp = "";
                    for (i = h * 3; i < h * 3 + 3; i++)    // Suche in Quadrat
                    {
                        for (j = v * 3; j < v * 3 + 3; j++)    // Hole jedes Element
                        {
                            s = dataGridView2.Rows[j].Cells[i].Value.ToString();
                            if (!(s == "") & !(s.Length == 1))
                            {
                                for (k = 0; k < s.Length; k++)
                                {
                                    zahl = Convert.ToInt32(s.Substring(k, 1)) -1;
                                    cnter[zahl]++; // in cnter steht, wie oft jede Zahl pro Z / SP vorkommt
                                }
                            }
                        }
                    }
                    // Jetzt reagieren auf Zählerstand 1
                    for (j = 0; j < 9; j++)
                        if (cnter[j] == 1)  // wenn Zahl genau nur einmal vorkommt-->Lösung
                        { //Feld mit dieser Lösungszahl suchen
                            zahl = j + 1; //Diese Zahl kommt nur einmal in Z /sp vor
                            for (j1 = v * 3; j1 < v * 3 + 3; j1++)   //In welchem Feld steht sie?
                                for (i = h * 3; i < h * 3 + 3; i++)
                                {
                                    s = dataGridView2.Rows[j1].Cells[i].Value.ToString();
                                    for (k = 0; k < s.Length; k++)
                                    {
                                        if (zahl == Convert.ToInt32(s.Substring(k, 1)))
                                        {
                                            if (dataGridView1.Rows[j1].Cells[i].Value != null)
                                            {
                                                alt = dataGridView1.Rows[j1].Cells[i].Value.ToString();
                                                if (alt.Length == 0) lsg++;
                                                tmp = Convert.ToString(j1) + Convert.ToString(i) + " " + Convert.ToString(zahl);
                                                Orte.Add(tmp + " just 1 time in B");
                                                if (CBuebernehm.Checked)
                                                    dataGridView1.Rows[j1].Cells[i].Value = zahl;  //Lösung
                                                dataGridView2.Rows[j1].Cells[i].Style.Font = fontDialog1.Font;
                                                N1Mlsg = true;
                                                j1 = v * 3 + 3; //Suche für diese Zahl beenden
                                                i = h * 3 + 3;
                                            }
                                        }
                                    }
                                }
                        }
                    initcnt();  // Für nächstes Quadrat neu Zählen
                } //Quadrat fertig for v,h ...
            return (N1Mlsg);
        }

        private void btnNur1_Click(object sender, EventArgs e)
        {
           
            bool N1Mlsg;
            int lsg = 0;
            int loop = 0, cntlsg = 0;
            if (!possifertig) MessageBox.Show("Please, first press button free number until OK");
            else
            {
                do
                {
                    loop++;
                    N1Mlsg = CheckObEineLsg(ref lsg);    // wenn true, hat Suche eine neue Zahl gefunden.
                    
                    cntlsg = cntlsg + lsg;
                    if (N1Mlsg)
                    {
                        possifertig = false;
                        btnpossi_Click(sender, e);  // Suche freie Zahlen
                    }
                }
                while ((possifertig) && (CBN1M.Checked) && (N1Mlsg));
                if (CBProto.Checked) listBox4.Items.Add("2:  DL= " + Convert.ToString(loop) + "  Lsg= "
                                                                    + Convert.ToString(cntlsg));
                if (CBFindloc.Checked)
                {
                    listBox4.Items.Clear();
                    foreach (string ort in Orte)
                    {
                        listBox4.Items.Add(ort);
                    }
                }
            } // do
        }

        private void btnCopyr_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    dataGridView3.Rows[i].Cells[j].Value = dataGridView1.Rows[i].Cells[j].Value;
                }
        }

        private void btnCopyl_Click(object sender, EventArgs e)
        {
            labfehler.Visible = false;
            labzsp.Visible = false;
            //btnClearOben_Click(sender, e);
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    
                    dataGridView1.Rows[i].Cells[j].Value = dataGridView3.Rows[i].Cells[j].Value;
                }
            
           // ButtonClEindClick(Sender);
            listBox4.Items.Clear();
        }

        private void btnCopydSolver_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    
                    dataGridView2.Rows[i].Cells[j].Value = dataGridView1.Rows[i].Cells[j].Value;
                }

        }

        int Taste1Solver()
        {   // Rückgabe 0 Alle Lösungen gefunden baer noch nicht fertig
            // Rückgabe 2  Widersprunch, zahl falsch
            // Rückgabe 1 alle 81 gefunden.
            bool lsg = false;
            String a;
            bool fehler = false;
            int loop = 0, cntlsg = 0;
            do
            {
                lsg = false;
                loop++;
                for (int i = 0; i < 9; i++)
                    for (int j = 0; j < 9; j++)
                    {
                        a = frei(i, j);
                        dataGridView2.Rows[i].Cells[j].Value = a;
                        if (dataGridView1.Rows[i].Cells[j].Value != null)
                        {
                            if ((a.Length == 1) & (dataGridView1.Rows[i].Cells[j].Value.ToString() == ""))
                            {  // Neue Lösung gefunden --> SG6
                                dataGridView1.Rows[i].Cells[j].Value = a;
                                lsg = true;
                                cntlsg++;
                            }
                            if (a.Length == 0) return (2);
                        }
                    }
            } while (lsg);
            if (CBProto.Checked)
                listBox4.Items.Add("1:  DL= " + Convert.ToString(loop) + "  Lsg= " + Convert.ToString(cntlsg));

            // zähle Zahlen in SG1, wenn nicht 81, return 0 sonst 1
            int cnt = 0;
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (dataGridView1.Rows[i].Cells[j].Value != null)
                    {
                        if (dataGridView1.Rows[i].Cells[j].Value.ToString().Length == 1) cnt++;
                        if (!check(i, j)) return (2);
                    }
                }
            if (cnt == 81) return (1); else return (0);
        }

        //---------------------------------------------------------------------------

        int Taste12Solver()
        {
            bool N1Mlsg;
            int lsgcnt =0;
            int mw = 0;
            int lsg = 0;
            int mwcnt;
            do
            {
                do    // 2. Strategie iterativ benutzen
                {
                    erg = Taste1Solver(); // Suche freie Zahlen
                    if (erg == 1) return (1); // Sudoku gelöst
                    if (erg == 2) return (2); // Sudoku Widerspruch
                    N1Mlsg = CheckObEineLsg(ref lsgcnt);  // wenn true, hat Suche eine neue Zahl gefunden.
                }
                while (N1Mlsg);
                mwcnt = 0;  // Hier wird gezählt, ob Möglichkeiten reduziert wurden
                if (CBneu.Checked)
                { // Beide Methoden Paartrick und Austrick reduzieren Möglichkeiten
                    do
                    {        // wende Paartrick an. Wenn Zahl gefunden, von oben neu anfangen
                        // wenn Möglichkeit weg, nochmal Paartrick
                        Paartrick(ref mw,ref lsg);
                        mwcnt = mwcnt + mw;
                        if (lsg == 0)  // wenn paartrick keine Zahl gefunden suche mit austrick weiter
                            do
                            {        // wende Austrick an. Wenn Zahl gefunden, von oben neu anfangen
                                // wenn Möglichkeit weg, nochmal Austrick
                                Austrick(ref mw,ref lsg);
                                mwcnt = mwcnt + mw;
                            }
                            while ((mw != 0) && (lsg == 0));
                    }
                    while ((mw != 0) && (lsg == 0));
                    if ((mwcnt > 0) && (lsg == 0)) N1Mlsg = CheckObEineLsg(ref lsg);
                } // end if CBneu

            }
            while ((CBneu.Checked) && (lsg > 0));
            return (0);  //Noch nicht fertig
        }

        //---------------------------------------------------------------------------
        private void Paartrick(ref int cntmoeg,ref int cntloes)
        {
        // Modul checkt, ob es in den Möglichkeiten Pärchen gibt, dann werden alle anderen Ziffern gelöscht
        // wenn cntmoeg =0 kein Pärchen gefunden mit Auswirkungen
        // wenn cntmoeg >0   eine oder mehrere Möglichkeiten konnten weg
        // wenn cntloes >0 dann eine oder mehrere Lösungszahlen gefunden
            int i, j, k, m, zahl, j1;
            String s, s2, sneu, z, zp1, zp2, tmp;
            //TStringList *Zweier =new TStringList();
            List<string> Zweier = new List<string>();
            //TStringList *paare =new TStringList();
            List<string> paare = new List<string>();
            cntmoeg = 0; cntloes = 0;
            Orte.Clear();
            for (i = 0; i < 9; i++)    // Suche in Spalte
            {
                Zweier.Clear();
                paare.Clear();
                for (j = 0; j < 9; j++)    // Hole jedes Element
                {
                    s = dataGridView2.Rows[i].Cells[j].Value.ToString();
                    if (s.Length == 2)
                    {
                        Zweier.Add(s); // Merke alle Zweier
                    }
                    // jetzt alle zweier gefunden
                }
                if (Zweier.Count > 1)
                {  //wenn mindestens 2 zweier
                    for (j = 0; j < Zweier.Count - 1; j++)
                    {
                        s2 = Zweier[j];
                        for (k = j + 1; k < Zweier.Count; k++)
                            if (s2 == Zweier[k]) paare.Add(s2);
                    } // end j
                } //end if
                if (paare.Count>0)
                    { // Wenn Paare gefunden, dann Möglichkeiten durchsuchen und Paarzahlen streichen
                    for (j=0;j<paare.Count;j++)
                        {
                        tmp="";
                        s2=paare[j];
                        for (k=0;k<9;k++) // Alle Elemente von SG2 durchsuchen
                        {
                            // hier neue Cell aufbauen
                            s= dataGridView2.Rows[i].Cells[k].Value.ToString();
                            if (s==s2) tmp=tmp+Convert.ToString(i)+Convert.ToString(k);
                            if ((s.Length>1)&&(s!=s2))
                            {
                                sneu="";
                                for (m=0;m<s.Length;m++)
                                {
                                z=s.Substring(m,1);
                                zp1=s2.Substring(0,1);
                                zp2=s2.Substring(1,1);
                                if ((z!=zp1)&&(z!=zp2)) sneu=sneu+z;
                                }
                                if (s.Length > sneu.Length)
                                    {
                                    cntmoeg++;
                                    tmp=tmp+Convert.ToString(i)+Convert.ToString(k);
                                    }
                                if (sneu.Length==1)
                                {
                                    cntloes++;
                                    if (CBuebernehm.Checked)
                                    dataGridView1.Rows[i].Cells[k].Value=sneu;
                                    dataGridView2.Rows[i].Cells[k].Style.Font = fontDialog1.Font;
                                }
                                dataGridView2.Rows[i].Cells[k].Value=sneu;
                            } // end if s.
                        } // end k
                        if (tmp.Length > 4) Orte.Add(tmp + " naked couple S");
                        } // end j
                    } // end if paare
                }// end i
            for (i = 0; i < 9; i++)    // Suche in Zeile
            {
                Zweier.Clear();
                paare.Clear();
                for (j = 0; j < 9; j++)    // Hole jedes Element
                {
                    s = dataGridView2.Rows[j].Cells[i].Value.ToString();
                    if (s.Length == 2)
                    {
                        Zweier.Add(s); // Merke alle Zweier
                    }
                    // jetzt alle zweier gefunden
                }
                if (Zweier.Count > 1)
                {  //wenn mindestens 2 zweier
                    for (j = 0; j < Zweier.Count - 1; j++)
                    {
                        s2 = Zweier[j];
                        for (k = j + 1; k < Zweier.Count; k++)
                            if (s2 == Zweier[k]) paare.Add(s2);
                    } // end j
                } //end if
                if (paare.Count > 0)
                { // Wenn Paare gefunden, dann Möglichkeiten durchsuchen und Paarzahlen streichen
                    for (j = 0; j < paare.Count; j++)
                    {
                        tmp = "";
                        s2 = paare[j];

                        for (k = 0; k < 9; k++) // Alle Elemente von SG2 durchsuchen
                        {
                            // hier neue Cell aufbauen
                            s = dataGridView2.Rows[k].Cells[i].Value.ToString();//Form1->StringGrid2->Cells[k][i];
                            if (s == s2) tmp = tmp + Convert.ToString(k) + Convert.ToString(i);
                            if ((s.Length > 1) && (s != s2))
                            {
                                sneu = "";
                                for (m = 0; m < s.Length; m++)
                                {
                                    z = s.Substring(m, 1);
                                    zp1 = s2.Substring(0, 1);
                                    zp2 = s2.Substring(1, 1);
                                    if ((z != zp1) && (z != zp2)) sneu = sneu + z;
                                }
                                if (s.Length > sneu.Length)
                                {
                                    cntmoeg++;
                                    tmp = tmp + Convert.ToString(k) + Convert.ToString(i);
                                }
                                if (sneu.Length == 1)
                                {
                                    cntloes++;
                                    if (CBuebernehm.Checked)
                                        dataGridView1.Rows[k].Cells[i].Value = sneu;
                                    dataGridView2.Rows[k].Cells[j].Style.Font = fontDialog1.Font;
                                }
                                dataGridView2.Rows[k].Cells[i].Value = sneu;
                            } // end if s.
                        } // end k
                        if (tmp.Length > 4) Orte.Add(tmp + " naked couple Z");
                    } // end j
                } // end if paare
            }// end i
            //  Dat janze noch mal in den 3*3 Quadraten prüfen
            int h,v;
            for (h=0;h<3;h++)  // h und v sind die Nummern der 3*3 Quadrate
            for (v=0;v<3;v++)
            {
                Zweier.Clear();
                paare.Clear();
                for (i=h*3;i<h*3+3;i++)    // Suche in Quadrat
                for (j=v*3;j<v*3+3;j++)    // Hole jedes Element
                {
            //  ------
                    s = dataGridView2.Rows[i].Cells[j].Value.ToString();
                if (s.Length==2)
                    {
                    Zweier.Add(s); // Merke alle Zweier
                    }
                    // jetzt alle zweier gefunden
                }
                if (Zweier.Count>1)
                    {  //wenn mindestens 2 Zweier
                    for (j=0;j<Zweier.Count-1;j++)
                    {
                    s2=Zweier[j];
                    for (k=j+1;k<Zweier.Count;k++)
                        if (s2==Zweier[k]) paare.Add(s2);
                    } // end j
                    } //end if
                if (paare.Count>0)
                    { // Wenn Paare gefunden, dann Möglichkeiten durchsuchen und Paarzahlen streichen
                    for (j=0;j<paare.Count;j++)
                        {
                        tmp="";
                        s2=paare[j];
                        for (i=h*3;i<h*3+3;i++)    // Suche in Quadrat
                        for (k=v*3;k<v*3+3;k++)    // Hole jedes Element
                        {
                            // hier neue Cell aufbauen
                            s = dataGridView2.Rows[i].Cells[k].Value.ToString();
                            if (s == s2) tmp = tmp + Convert.ToString(i) + Convert.ToString(k);
                            if ((s.Length>1)&&(s!=s2))
                            {
                                sneu="";
                                for (m=0;m<s.Length;m++)
                                {
                                z=s.Substring(m,1);
                                zp1=s2.Substring(0,1);
                                zp2=s2.Substring(1,1);
                                if ((z!=zp1)&&(z!=zp2)) sneu=sneu+z;
                                }
                                if (s.Length>sneu.Length)
                                    {
                                    cntmoeg++;
                                    tmp = tmp + Convert.ToString(i) + Convert.ToString(k);
                                    }
                                if (sneu.Length==1)
                                {
                                    cntloes++;
                                    if (CBuebernehm.Checked)
                                        dataGridView1.Rows[i].Cells[k].Value = sneu;
                                    dataGridView2.Rows[i].Cells[k].Style.Font = fontDialog1.Font;
                                }
                                dataGridView2.Rows[i].Cells[k].Value = sneu;
                            } // end if s.
                        } // end i,k
                        if (tmp.Length > 4) Orte.Add(tmp + " naked couple B");
                        } // end j
                    } // end if paare
                //------

                } // Block hv fertig
                if (CBProto.Checked)
                    listBox4.Items.Add("3:  Mw= " + Convert.ToString(cntmoeg) + " Lsg= " + Convert.ToString(cntloes));
                if (CBFindloc.Checked)
                {
                listBox4.Items.Clear();
                foreach (string ort in Orte)
                {
                    listBox4.Items.Add(ort);
                }
                }
        
        }
        //---------------------------------------------------------------------------   
        int[,] zcnt =new int [10, 10];
        int[,] scnt = new int[10, 10]; // Counter für die Zeilen [][0-8] und Spalten [][0-8] der einzenen Ziffern
        //---------------------------------------------------------------------------
        void clrcnt()
        {
            for (int i = 1; i < 10; i++)
                for (int j = 0; j < 10; j++)
                { zcnt[i,j] = 0; scnt[i,j] = 0; }
        }

        //---------------------------------------------------------------------------
        void Paartrickhiddenpair(ref int cntmoeg,ref int cntloes)
        {
        // Modul checkt, ob es in den Möglichkeiten verstecktes Pärchen gibt, dann werden die Ziffern über dem
        // Pärchen gelöscht.
        // In zcnt[i][j] steht in Spalte j=0 wie oft welche Zahl vorkommt.
        //               in Spalte j=1 wo die erste zahl steht (0-8)
        //                         j=2 wo die zweite zahl steht (0-8) usw.
        // Verstecktes Paar:  zwei Ziffern, die genau zweimal vorkommen und an den gleichen Stellen stehen
        // wenn cntmoeg =0 kein Pärchen gefunden mit Auswirkungen
        // wenn cntmoeg >0   eine oder mehrere Möglichkeiten konnten weg
        //  cntloes immer Null, da hier keine Lösungszahlen gefunden werden können
              int i,j,k,m,zahl,j1;
              String s,s2,sneu,z,zp1,zp2,tmp;
              List<string> paare = new List<string>();
              
              cntmoeg=0;cntloes=0;
              int cntmlok=0;  //Lokaler Zähler für mögliche Erfolge
              Orte.Clear();

              for (i=0;i<9;i++)    // Suche in Spalte
                  {
                   tmp="";
                   paare.Clear();
                   clrcnt();
                   for (j=0;j<9;j++)    // Hole jedes Element
                   {
                       s = dataGridView2.Rows[i].Cells[j].Value.ToString();
                        for (k=0;k<s.Length;k++)
                          {
                           zahl=Convert.ToInt32(s.Substring(k,1));
                           zcnt[zahl,0]++; // Hier jetzt die Anzahl der Ziffern
                           zcnt[zahl,zcnt[zahl,0]]=j;  // Position der Zahlen
                          }
                   }
                   for (k=1;k<10;k++)  //Suche Paare
                     if (zcnt[k,0]==2)  // Jetzt prüfe alle Ziffern, die zweimal vorkommen
                       for (m=k+1;m<10;m++) //  Wenn zweimal, prüfe, ob es noch einmal eine Ziffer gibt, die
                                            // zweimal vorkommt und gleiche Pos. haben
                        if ((zcnt[m,0]==2) && (zcnt[k,1]==zcnt[m,1]) && (zcnt[k,2]==zcnt[m,2]))
                            paare.Add(Convert.ToString(k) + Convert.ToString(m));  // verstecktes Paar gefunden

                    if (paare.Count>0)
                      { // Wenn Paare gefunden, dann Möglichkeiten durchsuchen und Paarzahlen streichen
                       for (j=0;j<paare.Count;j++)
                         {
                          s2=paare[j];

                          for (k=0;k<9;k++) // Alle Elemente von SG2 durchsuchen
                            {
                               // hier neue Cell aufbauen
                             s= dataGridView2.Rows[i].Cells[k].Value.ToString();
                             if ((s.Length>1))
                                {
                                 for (m=0;m<s.Length;m++)
                                   {
                                    z=s.Substring(m,1);
                                    zp1=s2.Substring(0,1);
                                    zp2=s2.Substring(1,1);
                                    if ((z==zp1)||(z==zp2))
                                       {  // Wenn Stelle mit Paar gefunden : Wert=Paar
                                        if (s.Length>2)cntmlok++;
                                        tmp = tmp + Convert.ToString(i) + Convert.ToString(k);
                                        m=10; // beende m-Schleife
                                        dataGridView2.Rows[i].Cells[k].Value = s2;
                                       }
                                   }
                                } // end if s.
                            } // end k
                         } // end j
                      } // end if paare
                    if ((tmp.Length > 3) && (cntmlok > 0)) Orte.Add(tmp + " hidden couple S");
                  }// end i
              cntmoeg=cntmlok;
              cntmlok=0;
              for (i=0;i<9;i++)    // Suche in Zeile
                  {
                   tmp="";
                   paare.Clear();
                   clrcnt();
                   for (j=0;j<9;j++)    // Hole jedes Element
                   {
                       s = dataGridView2.Rows[j].Cells[i].Value.ToString();
                        for (k=0;k<s.Length;k++)
                          {
                              zahl = Convert.ToInt32(s.Substring(k, 1));
                           zcnt[zahl,0]++; // Hier jetzt die Anzahl der Ziffern
                           zcnt[zahl,zcnt[zahl,0]]=j;  // Position der Zahlen
                          }
                   }
                   for (k=1;k<10;k++)  //Suche Paare
                     if (zcnt[k,0]==2)  // Jetzt prüfe alle Ziffern, die zweimal vorkommen
                       for (m=k+1;m<10;m++) //  Wenn zweimal, prüfe, ob es noch einmal eine Ziffer gibt, die
                                            // zweimal vorkommt und gleiche Pos. haben
                        if ((zcnt[m,0]==2) && (zcnt[k,1]==zcnt[m,1]) && (zcnt[k,2]==zcnt[m,2]))
                            paare.Add(Convert.ToString(k) + Convert.ToString(m));  // verstecktes Paar gefunden

                    if (paare.Count>0)
                      { // Wenn Paare gefunden, dann Möglichkeiten durchsuchen und Paarzahlen streichen
                       for (j=0;j<paare.Count;j++)
                         {
                          s2=paare[j];

                          for (k=0;k<9;k++) // Alle Elemente von SG2 durchsuchen
                            {
                               // hier neue Cell aufbauen
                                s = dataGridView2.Rows[k].Cells[i].Value.ToString();
                             if ((s.Length>1))
                                {
                                 for (m=0;m<s.Length;m++)
                                   {
                                    z=s.Substring(m,1);
                                    zp1=s2.Substring(0,1);
                                    zp2=s2.Substring(1,1);
                                    if ((z==zp1)||(z==zp2))
                                       {  // Wenn Stelle mit Paar gefunden : Wert=Paar
                                        if (s.Length>2)cntmlok++;
                                        tmp = tmp + Convert.ToString(k) + Convert.ToString(i);
                                        m=10; // beende m-Schleife
                                        dataGridView2.Rows[k].Cells[i].Value = s2;
                                       }
                                   }
                                } // end if s.
                            } // end k
                         } // end j
                      } // end if paare
                    if ((tmp.Length > 3) && (cntmlok > 0)) Orte.Add(tmp + " hidden couple Z");
                  }// end i
              cntmoeg=cntmoeg+cntmlok;
              cntmlok=0;


            //  Dat janze noch mal in den 3*3 Quadraten prüfen
              int h,v,pos;
              cntmlok=0;
              for (h=0;h<3;h++)  // h und v sind die Nummern der 3*3 Quadrate
               for (v=0;v<3;v++)
               {
                 tmp="";
                 clrcnt();
                 paare.Clear();
                 pos=0;  // positionszähler
                 for (i=h*3;i<h*3+3;i++)    // Suche in Quadrat
                  for (j=v*3;j<v*3+3;j++)    // Hole jedes Element
                   {
            //  ------
                       s = dataGridView2.Rows[i].Cells[j].Value.ToString();
                        for (k=0;k<s.Length;k++)
                          {
                              zahl = Convert.ToInt32(s.Substring(k, 1));
                           zcnt[zahl,0]++; // Hier jetzt die Anzahl der Ziffern
                           zcnt[zahl,zcnt[zahl,0]]=pos;  // Position der Zahlen
                          }
                    pos++;
                   }
                   for (k=1;k<10;k++)  //Suche Paare
                     if (zcnt[k,0]==2)  // Jetzt prüfe alle Ziffern, die zweimal vorkommen
                       for (m=k+1;m<10;m++) //  Wenn zweimal, prüfe, ob es noch einmal eine Ziffer gibt, die
                                            // zweimal vorkommt und gleiche Pos. haben
                        if ((zcnt[m,0]==2) && (zcnt[k,1]==zcnt[m,1]) && (zcnt[k,2]==zcnt[m,2]))
                            paare.Add(Convert.ToString(k) + Convert.ToString(m));  // verstecktes Paar gefunden

                    if (paare.Count>0)
                      { // Wenn Paare gefunden, dann Möglichkeiten durchsuchen und Paarzahlen streichen
                       for (j=0;j<paare.Count;j++)
                         {
                          s2=paare[j];

                          for (i=h*3;i<h*3+3;i++)    // Suche in Quadrat
                            for (k=v*3;k<v*3+3;k++)    // Hole jedes Element
                             {
                               // hier neue Cell aufbauen
                                 s = dataGridView2.Rows[i].Cells[k].Value.ToString();
                             if ((s.Length>1))
                                {
                                 for (m=0;m<s.Length;m++)
                                   {
                                    z=s.Substring(m,1);
                                    zp1=s2.Substring(0,1);
                                    zp2=s2.Substring(1,1);
                                    if ((z==zp1)||(z==zp2))
                                       {  // Wenn Stelle mit Paar gefunden : Wert=Paar
                                        if (s.Length>2)cntmlok++;
                                        tmp = tmp + Convert.ToString(i) + Convert.ToString(k);
                                        m=10; // beende m-Schleife
                                        dataGridView2.Rows[i].Cells[k].Value = s2;
                                       }
                                   }
                                } // end if s.
                            } // end k
                         } // end j
                      } // end if paare
                    if ((tmp.Length > 3) && (cntmlok > 0)) Orte.Add(tmp + " hidden couple B");
                  }// end h,v

              cntmoeg=cntmoeg+cntmlok;

             if (CBProto.Checked)
                 listBox4.Items.Add("4:  Mw= " + Convert.ToString(cntmoeg));
             if (CBFindloc.Checked)
                 {
                     listBox4.Items.Clear();
                     foreach (string ort in Orte)
                     {
                         listBox4.Items.Add(ort);
                     }
                 }
             //delete paare;
        }

        private void CBProto_CheckedChanged(object sender, EventArgs e)
        {
            if (CBProto.Checked) CBFindloc.Checked = false;
            listBox4.Visible = CBProto.Checked;
            if (!CBProto.Checked) listBox4.Items.Clear();
        }

        private void CBFindloc_CheckedChanged(object sender, EventArgs e)
        {
            if (CBFindloc.Checked) CBProto.Checked = false;
            listBox4.Visible = CBFindloc.Checked;
            listBox4.Items.Clear();
            foreach (string ort in Orte)
            {
                listBox4.Items.Add(ort);
            }
        }
        //---------------------------------------------------------------------------

        void Austrick(ref int cntmoeg,ref int cntloes)
        {
        // Modul checkt, ob Möglichkeiten nur in einer Z oder Sp pro Modul vorkommt, dann werden alle anderen Ziffern gelöscht
        // wenn cntmoeg =0 kein Pärchen gefunden mit Auswirkungen
        // wenn cntmoeg >0   eine oder mehrere Möglichkeiten konnten weg
        // wenn cntloes >0 dann eine oder mehrere Lösungszahlen gefunden
          int i,j,k,m,zahl,zerfolg,serfolg;
          String s,s2,sneu,z,zp1,zp2,tmp;
          int h,v;
          clrcnt();  // Zähler Null
          cntmoeg=0;cntloes=0;
          Orte.Clear();
          for (h=0;h<3;h++)  // h und v sind die Nummern der 3*3 Quadrate
           for (v=0;v<3;v++)
           {
             clrcnt();  // Zähler Null
             for (i=h*3;i<h*3+3;i++)    // Suche in Quadrat
              for (j=v*3;j<v*3+3;j++)    // Hole jedes Element
               {
                   s = dataGridView2.Rows[i].Cells[j].Value.ToString();
                if (s.Length>1)
                    for (k=0;k<s.Length;k++)
                      {
                          zcnt[Convert.ToInt32(s.Substring(k, 1)),j]++;
                          scnt[Convert.ToInt32(s.Substring(k, 1)),i]++;
                      }

               }  // Block zählen fertig
              for (zahl=1;zahl<10;zahl++) // Alle Zahlen durchgehen
                { //wenn in zcnt oder scnt in einem Block eine 2/0/0 oder 0/2/0 oder 0/0/2 steht Statt 2 auch 3
                  // dann löscht diese Kombination in der ensprechenden Zeile diese Zahl weg.
                 zerfolg=-1;                // Wenn Zahl nicht mehr als einmal vorkommt: nix
                 tmp="";
                 if ((zcnt[zahl,v*3]>1)&&(zcnt[zahl,v*3+1]==0)&&(zcnt[zahl,v*3+2]==0)) zerfolg=v*3;
                   else if ((zcnt[zahl,v*3+1]>1)&&(zcnt[zahl,v*3]==0)&&(zcnt[zahl,v*3+2]==0)) zerfolg=v*3+1;
                      else if ((zcnt[zahl,v*3+2]>1)&&(zcnt[zahl,v*3]==0)&&(zcnt[zahl,v*3+1]==0)) zerfolg=v*3+2;
                 if (zerfolg>-1) // Dann gibt es die Exclusivzeile für Zahl
                      { //Jetzt in dieser Zeile aus den anderen Möglichkeiten Zahl entfernen
                       for (i=0;i<9;i++) // gehe alle Elemente dieser Zeile durch
                          {
                           // hier neue Cell aufbauen
                           
                           s = dataGridView2.Rows[i].Cells[zerfolg].Value.ToString();
                           if ((s.Length>1)&&(i/3!=h))
                            {
                             sneu="";
                             for (m=0;m<s.Length;m++)
                               {
                                z=s.Substring(m,1);
                                if (z!=zahl.ToString()) sneu=sneu+z;
                               }
                             if (s.Length>sneu.Length)
                                {
                                 cntmoeg++;
                                 tmp = tmp + Convert.ToString(i) + Convert.ToString(zerfolg);
                                }
                             if (sneu.Length==1)
                                {
                                 cntloes++;
                                 if (CBuebernehm.Checked)
                                     dataGridView1.Rows[i].Cells[zerfolg].Value = sneu;
                                     dataGridView2.Rows[i].Cells[zerfolg].Style.Font = fontDialog1.Font;
                                }
                             dataGridView2.Rows[i].Cells[zerfolg].Value = sneu;
                            } // end if s.
                          } // end i
                      } // end if
                 if (tmp.Length > 0) Orte.Add(tmp + " " + Convert.ToString(zahl) + " can get away in Z");
                } // end zahl

              // Das wird jetzt wiederholt und für die Spalten geprüft
              for (zahl=1;zahl<10;zahl++) // Alle Zahlen durchgehen
                {
                 zerfolg=-1;                // Wenn Zahl nicht mehr als einmal vorkommt: nix
                 tmp="";
                 if ((scnt[zahl,h*3]>1)&&(scnt[zahl,h*3+1]==0)&&(scnt[zahl,h*3+2]==0)) zerfolg=h*3;
                   else if ((scnt[zahl,h*3+1]>1)&&(scnt[zahl,h*3]==0)&&(scnt[zahl,h*3+2]==0)) zerfolg=h*3+1;
                      else if ((scnt[zahl,h*3+2]>1)&&(scnt[zahl,h*3]==0)&&(scnt[zahl,h*3+1]==0)) zerfolg=h*3+2;
                 if (zerfolg>-1) // Dann gibt es die Exclusivzeile für Zahl
                      { //Jetzt in dieser Zeile aus den anderen Möglichkeiten Zahl entfernen
                       for (i=0;i<9;i++) // gehe alle Elemente dieser Zeile durch
                          {
                           // hier neue Cell aufbauen
                              s = dataGridView2.Rows[zerfolg].Cells[i].Value.ToString();
                           if ((s.Length>1)&&(i/3!=v))
                            {
                             sneu="";
                             for (m=0;m<s.Length;m++)
                               {
                                z=s.Substring(m,1);
                                if (z!=zahl.ToString()) sneu=sneu+z;
                               }
                             if (s.Length>sneu.Length)
                                 {
                                  cntmoeg++;
                                  tmp = tmp + Convert.ToString(zerfolg) + Convert.ToString(i);
                                  }
                             if (sneu.Length==1)
                                {
                                 cntloes++;
                                 if (CBuebernehm.Checked)
                                     dataGridView1.Rows[zerfolg].Cells[i].Value = sneu;
                                     dataGridView2.Rows[zerfolg].Cells[i].Style.Font = fontDialog1.Font;
                                }
                             dataGridView2.Rows[zerfolg].Cells[i].Value = sneu;
                            } // end if s.

                          }// end i
                      } // end if
                 if (tmp.Length > 0) Orte.Add(tmp + " " + Convert.ToString(zahl) + " can get away in S");
                } // end zahl

           } // Blöcke fertig
         if (CBProto.Checked)
             listBox4.Items.Add("5:  Mw= " + Convert.ToString(cntmoeg) + " Lsg= " + Convert.ToString(cntloes));
         if (CBFindloc.Checked)
             {
                 listBox4.Items.Clear();
                 foreach (string ort in Orte)
                 {
                     listBox4.Items.Add(ort);
                 }
             }

        }
        //---------------------------------------------------------------------------
        private void btnParrtrick_Click(object sender, EventArgs e)
        {
            int moeg=0;
            int loes=0;
               
            if (CBN1M.Checked) Taste12Solver();
            else
            {
                Paartrick(ref moeg,ref loes);
                if (loes > 0) label123.Text = "NotOK";
            }
        }
        //---------------------------------------------------------------------------
        private void btnHidPair_Click(object sender, EventArgs e)
        {
            int moeg = 0;
            int loes = 0;
            if (CBN1M.Checked) Taste12Solver();
            else Paartrickhiddenpair(ref moeg,ref loes);
        }
        //---------------------------------------------------------------------------
        private void btnAusschlie_Click(object sender, EventArgs e)
        {
            int moeg = 0;
            int loes = 0;
            if (CBN1M.Checked) Taste12Solver();
            else
            {
                Austrick(ref moeg,ref loes);
                if (loes > 0) label123.Text = "NotOK";
            }
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            Bitmap bm = new Bitmap(this.dataGridView2.Width, this.dataGridView2.Height);
            dataGridView2.DrawToBitmap(bm, new Rectangle(0, 0, this.dataGridView2.Width, this.dataGridView2.Height));
            e.Graphics.DrawImage(bm, 0, 0);
        }

        private void btnPrint_Click(object sender, EventArgs e)
        {
            printDocument1.Print();
        }
        void copySG1toSG6()
        {
            //  copy SG1--> SG6
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    
                        dataGridView6.Rows[i].Cells[j].Value = dataGridView1.Rows[i].Cells[j].Value;
                    
                }
           
        }
        void copySL12SG1()
        {

            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                   
                        dataGridView1.Rows[i].Cells[j].Value = SL1[j + i * 9];
                    
        }
        void copySL22SG2()
        {

            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                    
                        dataGridView2.Rows[i].Cells[j].Value = SL2[j + i * 9];
                    
        }
        void copySG12SL1()
        {
            SL1.Clear();
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                    //if (dataGridView1.Rows[i].Cells[j].Value != null)
                    //{
                        SL1.Add(dataGridView1.Rows[i].Cells[j].Value.ToString());
                    //}
                    //else SL1.Add("");
        }
        void copySG22SL2()
        {
            SL2.Clear();
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                    
                         SL2.Add(dataGridView2.Rows[i].Cells[j].Value.ToString()); 
                    
        }
        bool cmpSG1SG6()
        {   // Vergleiche SG1 mit SG6, wenn gleich, dann weg mit true

            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                    if (dataGridView1.Rows[i].Cells[j].Value != null)
                    {
                        if (dataGridView1.Rows[i].Cells[j].Value != dataGridView6.Rows[i].Cells[j].Value) return (false);
                    }
            return (true);
        }

        //---------------------------------------------------------------------------
        int cntlsg,deep,BTcnt, dmax,cntsolve;
        int[] cntmax=new int[30];
        int[] cntvar=new int[30]; // Zählerstand
        bool Abortbt;

        int BackTrack()
           {
            //List<string> SL1 = new List<string>();
            //List<string> SL2 = new List<string>();
            //string[,] SL1 = new string[9, 9];
            //string[,] SL2 = new string[9, 9];
            
            String a,Zahl;
            int len,erg,BTerg,i,j;
            
            copySG12SL1();
            copySG22SL2();

            
            deep++;BTcnt++;
            //if (BTcnt==78)
            //   BTcnt=78;
            if (BTcnt>CSpinEdit9.Value) Abortbt=true;
            if (deep>dmax) dmax=deep;
            if (CBDisplay.Checked)
            {
                // progressBar1.Position=deep;
                progressBar1.Value = deep;
                progressBar1.Refresh();
                label184.Text = Convert.ToString(deep) + "             ";
                label184.Refresh();
                //Form1->ProgressBar1->Refresh();
                //Form1->Label19->Caption=IntToStr(deep)+ "             " ;
                //Form1->Label19->Refresh();
            }
            //Form1->Label23->Caption = IntToStr(BTcnt) + "             ";
            //Form1->Label23->Refresh();
            label19.Text = Convert.ToString(BTcnt) + "             ";
            label19.Refresh();
            //Application->ProcessMessages();
            Application.DoEvents();


            // Check, wie groß für schnelle Lösung ohne Eindeutigkeitstest die kleinste Variante ist
            int minvar=9,cntpossi=0;
            for (i = 0; i < 9; i++)
                for (j = 0; j < 9; j++)
                {
                    len = dataGridView2.Rows[i].Cells[j].Value.ToString().Length;
                    if (len > 1)
                    {
                        if (len < minvar) minvar = len;  // Bestimme kleinste Variante außer 1
                        cntpossi = cntpossi + len;       // Zähle Varianten dieser Tiefe
                    }
                }
            cntmax[deep]=cntpossi; // Max. Variantenzahl merken
            cntvar[deep]=0;  // Zählen starten
            for (i=0;i<9;i++)
              for (j=0;j<9;j++)
               {
                //Sleep(20);

                   if ((deep == 1) && (CBDisplay.Checked))
                   {
                       progressBar2.Value = i * 9 + j;
                       progressBar2.Refresh();
                       label25.Text = "already " + Convert.ToString(i * 9 + j) + " from " + Convert.ToString(80) + "            ";
                       label25.Refresh();
                       label27.Text = Convert.ToString(cntsolve) + " calculations";
                       label27.Refresh();
                       //Form1->ProgressBar2->Position=i*9+j;
                       //Form1->ProgressBar2->Refresh();
                       //Form1->Label25->Caption="schon "+IntToStr(i*9+j)+" von "+IntToStr(80)+"            ";
                       //Form1->Label25->Refresh();
                       //Form1->Label27->Caption=IntToStr(cntsolve)+" Berechnungen";
                       //Form1->Label27->Refresh();
                   }
                len = dataGridView2.Rows[i].Cells[j].Value.ToString().Length;

                if ((!CheckBoxEind.Checked) && (len > minvar)) ;  // nehme nur die kleinsten Varianten
                else
                {
                    if (len > 1)  for (int k = 0; k < len; k++)  // Klappere alle freien Möglichkeiten ab
                        { // Wähle eine von+ den freien Möglichkeiten und versuche Lösung zu finden
                            Zahl = dataGridView2.Rows[i].Cells[j].Value.ToString().Substring(k, 1);
                            dataGridView1.Rows[i].Cells[j].Value = Zahl;
                            /*/ debug
                            if ((BTcnt==Form1->CSpinEdit9->Value));//&& (i==0) &&(j==5))
                             {
                              copySGtoSG(Form1->StringGrid2,Form1->StringGrid5); //Debug
                              copySGtoSG(Form1->StringGrid1,Form1->StringGrid4); //Debug
                              }
                            // debug */
                            erg = Taste12Solver();
                            cntsolve++;
                            cntvar[deep]++;
                            // debug
                            //Form1->ListBox3->Items->Add("CNT="+IntToStr(BTcnt)+"d="+IntToStr(deep)+"i="+IntToStr(i)+"j="+IntToStr(j)+"k="+IntToStr(k)+"Z="+Zahl+"e="+IntToStr(erg));
                            // debug
                            if (CBDisplay.Checked)
                            {
                                label24.Text = ("d=" + Convert.ToString(deep) + " " + Convert.ToString(cntvar[deep]) + " von " + Convert.ToString(cntmax[deep]) + "            ");
                                label24.Refresh();
                                label27.Text = Convert.ToString(cntsolve) + " Berechnungen";
                                label27.Refresh();
                                //Form1->Label24->Caption=("d="+IntToStr(deep)+" "+IntToStr(cntvar[deep])+" von "+IntToStr(cntmax[deep])+"            ");
                                //Form1->Label24->Refresh();
                                //Form1->Label27->Caption=IntToStr(cntsolve)+" Berechnungen";
                                //Form1->Label27->Refresh();
                            }
                            switch (erg)
                            {
                                case 0:
                                    {          // suche rekursiv weiter nach Lösung oder Widerspruch
                                        BTerg = BackTrack();
                                        if ((BTerg == 3) || (BTerg == 4) || (BTerg == 5) || (Abortbt))
                                        {
                                            if (Abortbt) BTerg = 5;
                                            
                                            //SL1.Clear();
                                            //SL2.Clear();
                                            deep--;
                                            return (BTerg);  // Bei 3  doppelte Lösung, nicht eindeutig Bei 4 Fertig 1 Lösung
                                        }
                                        break;
                                    }
                                case 1:
                                    {     // Alle 81 Zahlen sind gelöst
                                        if (cntlsg == 0)
                                        {
                                            copySG1toSG6();
                                            if (!CheckBoxEind.Checked)
                                            {
                                                
                                                //SL1.Clear();
                                                //SL2.Clear();
                                                deep--;
                                                return (4); // Bei 4 ohne Eindeutigkeitsprüfung
                                            }
                                        }
                                        else // wenn schon Lösung existiert, vergleiche
                                        {
                                            bool gleich = cmpSG1SG6();

                                            if (!gleich)
                                            {
                                                
                                                //SL1.Clear();
                                                //SL2.Clear();
                                                
                                                deep--;
                                                return (3); // Bei 3  doppelte Lösung, nicht eindeutig
                                            }
                                        }
                                        cntlsg = 1;
                                        break;
                                    }
                            } // end switch erg

                            copySL12SG1();      // Zurückkopieren für nächsten Schritt
                            copySL22SG2();
                        } // end if
                } // end else
               } // end for
            //SL1.Clear();
            //SL2.Clear();
            //delete SL1;
            //delete SL2;
            deep--;
        
            return(cntlsg);   // Bei 0:  keine Lösung, Bei 1 eine eindeitige Lösung
            
           }

        private void btnBacktrack_Click(object sender, EventArgs e)
        {
            CheckBoxEind.Checked = false;  // Kein Eindeutigkeitscheck
            btnCopydSolver_Click(sender, e);
            btnpossi_Click(sender, e);
            cntsolve = 0;
            cntlsg = 0; deep = 0; BTcnt = 0; // Lösungszähler auf Null
            int BTerg = BackTrack();
            if (CBProto.Checked) listBox4.Items.Add("5:  cnt= " + Convert.ToString(cntsolve) + " deep= " + Convert.ToString(deep));
        }

        private void printDocument2_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            Bitmap bm = new Bitmap(this.dataGridView3.Width, this.dataGridView3.Height);
            dataGridView3.DrawToBitmap(bm, new Rectangle(0, 0, this.dataGridView3.Width, this.dataGridView3.Height));
            e.Graphics.DrawImage(bm, 0, 0);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            printDocument2.Print();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnClearOben_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 9; i++)  
                for (int j = 0; j < 9; j++)
                {
                    dataGridView1.Rows[i].Cells[j].Value = "";
                    dataGridView2.Rows[i].Cells[j].Value = "";
                    dataGridView3.Rows[i].Cells[j].Value = "";
                   // StringGrid6->Cells[i][j] = "";
                }
            listBox4.Items.Clear();
        }

        private void btnClr_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 9; i++)  // alle Zeichen außer 1-9 durch Leerstring ersetzen
                for (int j = 0; j < 9; j++)
                {
                    dataGridView1.Rows[i].Cells[j].Value = "";
                    dataGridView2.Rows[i].Cells[j].Value = "";
                    dataGridView3.Rows[i].Cells[j].Value = "";
                    dataGridView4.Rows[i].Cells[j].Value = "";
                    dataGridView6.Rows[i].Cells[j].Value = "";
                    
                }
            listBox4.Items.Clear();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                Memo1.Clear();
                List<string> add = new List<string>();
                string a = " ";
                string b;
                
                add.Add(label1.Text);
                for (int i = 0; i < 9; i++)
                {
                    a = "";
                    for (int j = 0; j < 9; j++)
                    {
                        b = dataGridView1.Rows[i].Cells[j].Value.ToString();
                        if (b == "") a =a+ " "; else a = a + b;
                    }
                    add.Add(a);
                    Memo1.Lines = add.ToArray();
                    
                    StreamWriter myStream1 = new
                            StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
                    myStream1.WriteLine(Memo1.Text);
                    myStream1.Close();
                }

            }
        }
        void ClearSG6()
        {
            for (int i = 0; i < 9; i++)  // alle Zeichen außer 1-9 durch Leerstring ersetzen
                for (int j = 0; j < 9; j++)
                {
                    dataGridView6.Rows[i].Cells[j].Value = "";
                    
                }
        }
        void copySG6toSG1()
        {
            for (int i = 0; i < 9; i++)  
                for (int j = 0; j < 9; j++)
                {
                    dataGridView6.Rows[i].Cells[j].Value = dataGridView1.Rows[i].Cells[j].Value;

                }
        }
        private void btnSolveCheck_Click(object sender, EventArgs e)
        {
            btnpossi_Click(sender, e);
            CBProto.Checked = false;    // Ohne Display auf Solverseite
            CBFindloc.Checked = false;  // Ohne Display auf Solverseite
            label27.Visible = false;
            //BitBtnAbort->Visible = true;
            label27.Refresh();
            int BTerg;
            Abortbt = false;
            cntsolve = 0;
            //grid();
            //ListBox3->Clear();
            //col18(clBlack);
            label18.Text = "Check in work                       ";
            label18.Refresh();
            ClearSG6();
            progressBar1.Value = 0;
            progressBar2.Value = 0;
            label184.Text = "1             ";
            label184.Refresh();
            label19.Text = "1             ";
            label19.Refresh();
            label24.Text = "             ";
            label24.Refresh();
            label25.Text = "             ";
            label25.Refresh();
            
            dmax = 0;

            for (int x = 0; x < 30; x++) { cntvar[x] = 0; cntmax[x] = 0; }


           int erg = Taste12Solver();

            switch (erg)
            {
                case 1: label18.Text = "Sudoku solved uniquely          "; break;
                case 2: label18.Text = "Sudoku can not be solved              "; break;
                case 0:
                    { // Backtrack Lösung
                        cntlsg = 0; deep = 0; BTcnt = 0; // Lösungszähler auf Null
                        BTerg = BackTrack();
                        switch (BTerg)
                        {
                            case 1: label18.Text = "Sudoku solved uniquely"; copySG6toSG1(); break;
                            case 4: label18.Text = "Sudoku solved, not checked"; copySG6toSG1(); break;
                            case 0: label18.Text = "Sudoku can not be solved                "; break;
                            case 3: label18.Text = "Sudoku have more solution    ";  break;
                            case 5: label18.Text = "Check breaked                  ";  break;
                        } // end switch BTerg
                        label184.Text = Convert.ToString(deep) + " max= " + Convert.ToString(dmax);
                        label184.Refresh();
                        label19.Text = Convert.ToString(BTcnt) + "             ";
                        label19.Refresh();
                        progressBar1.Value = deep;
                        progressBar1.Refresh();
                        label27.Visible = true;
                        label27.Text = Convert.ToString(cntsolve) + " calculations";
                        label27.Refresh();
                        
                        //Form1->BitBtnAbort->Visible = false;

                        break;

                    } // end erg case 0
            } // end switch erg
        }

        private void dataGridView6_Paint(object sender, PaintEventArgs e)
        {
            Pen p = new Pen(Color.Black, 2);
            Point poi1 = new Point(0, 92);
            Point poi2 = new Point(278, 92);
            e.Graphics.DrawLine(p, poi1, poi2);
            Point poi3 = new Point(0, 183);
            Point poi4 = new Point(278, 183);
            e.Graphics.DrawLine(p, poi3, poi4);
            Point poi5 = new Point(92, 0);
            Point poi6 = new Point(92, 278);
            e.Graphics.DrawLine(p, poi5, poi6);
            Point poi7 = new Point(183, 0);
            Point poi8 = new Point(183, 278);
            e.Graphics.DrawLine(p, poi7, poi8);
        }

        void tauschsp(int a, int b)
        {
            String weg;
            for (int i = 0; i < 9; i++)
            {
                weg = dataGridView1.Rows[i].Cells[a].Value.ToString();
                dataGridView1.Rows[i].Cells[a].Value = dataGridView1.Rows[i].Cells[b].Value;
                dataGridView1.Rows[i].Cells[b].Value = weg;
                weg = dataGridView3.Rows[i].Cells[a].Value.ToString();
                dataGridView3.Rows[i].Cells[a].Value = dataGridView3.Rows[i].Cells[b].Value;
                dataGridView3.Rows[i].Cells[b].Value = weg;
            }

        }

        private void btnTauschSp_Click(object sender, EventArgs e)
        {   // Vertausche Spalten mit Nummern aus den SpinEdits der oberen beiden Sudokus
            tauschsp(Convert.ToInt32(CSpinEdit1.Value - 1), Convert.ToInt32(CSpinEdit2.Value -1));
            if (CBSymm.Checked) // Dann werden auch die symmetrischen Z / Sp getauscht
            {
                tauschsp(Convert.ToInt32(9 - CSpinEdit1.Value),Convert.ToInt32 (9 - CSpinEdit2.Value));

            }
        }
        void tauschz(int a, int b)  // Tausche Cells index a mit b
        {
            String weg;
            for (int i = 0; i < 9; i++)
            {
                weg = dataGridView1.Rows[a].Cells[i].Value.ToString();
                dataGridView1.Rows[a].Cells[i].Value = dataGridView1.Rows[b].Cells[i].Value;
                dataGridView1.Rows[b].Cells[i].Value = weg;
                weg = dataGridView3.Rows[a].Cells[i].Value.ToString();
                dataGridView3.Rows[a].Cells[i].Value = dataGridView3.Rows[b].Cells[i].Value;
                dataGridView3.Rows[b].Cells[i].Value = weg;
            }

        }

        private void btnTauschZ_Click(object sender, EventArgs e)
        {   // Vertausche Zeilen mit Nummern aus den SpinEdits der oberen beiden Sudokus
            tauschz(Convert.ToInt32(CSpinEdit1.Value - 1), Convert.ToInt32(CSpinEdit2.Value - 1));
            if (CBSymm.Checked) // Dann werden auch die symmetrischen Z / Sp getauscht
            {
                tauschz(Convert.ToInt32(9 - CSpinEdit1.Value), Convert.ToInt32(9 - CSpinEdit2.Value));

            }
        }

        private void btnTranspon_Click(object sender, EventArgs e)
        {
            String weg;
            for (int j = 0; j < 9; j++)
                for (int i = j + 1; i < 9; i++)
                {
                    weg = dataGridView1.Rows[i].Cells[j].Value.ToString();
                    dataGridView1.Rows[i].Cells[j].Value = dataGridView1.Rows[j].Cells[i].Value;
                    dataGridView1.Rows[j].Cells[i].Value = weg;
                    weg = dataGridView3.Rows[i].Cells[j].Value.ToString();
                    dataGridView3.Rows[i].Cells[j].Value = dataGridView3.Rows[j].Cells[i].Value;
                    dataGridView3.Rows[j].Cells[i].Value = weg;
                }
        }

        private void CSpinEdit1_ValueChanged(object sender, EventArgs e)
        {
            //CSpinEdit2.Minimum = ((CSpinEdit1.Value - 1) / 3) * 3 + 1;
            //CSpinEdit2.Maximum = ((CSpinEdit1.Value - 1) / 3) * 3 + 3;
            //CSpinEdit2.Value = ((CSpinEdit1.Value - 1) / 3) * 3 + 1;
            if (CSpinEdit1.Value > 3)
            {
                btnTauschBsp.Visible = false;
                btnTauschBz.Visible = false;
               
            }
            else
            {
                btnTauschBsp.Visible = true;
                btnTauschBz.Visible = true;

            }
        }
        void tauscheBZ(int a, int b)
        {
            if (CBSymm.Checked & ((a == 1) | (b == 1))) ; //kein Blocktausch
            else
            {
                for (int i = 0; i < 3; i++)
                    tauschz((a) * 3 + i, (b) * 3 + i);
            }

        }
        void tauscheBSp(int a, int b)
        {
            if (CBSymm.Checked & ((a == 1) | (b == 1))) ; //kein Blocktausch
            else
            {
                for (int i = 0; i < 3; i++)
                    tauschsp((a) * 3 + i, (b) * 3 + i);
            }

        }

        private void btnTauschBsp_Click(object sender, EventArgs e)
        {
            tauscheBSp(Convert.ToInt32(CSpinEdit1.Value - 1), Convert.ToInt32(CSpinEdit2.Value - 1));
        }

        private void btnTauschBz_Click(object sender, EventArgs e)
        {
            tauscheBZ(Convert.ToInt32(CSpinEdit1.Value - 1), Convert.ToInt32(CSpinEdit2.Value - 1));
        }

        private void btnMix_Click(object sender, EventArgs e)
        {
            Random random = new Random();
            for (int i = 0; i < 100; i++)
            {
                tauscheBZ(random.Next(1,3),random.Next(1,3));
                tauscheBSp(random.Next(1, 3), random.Next(1, 3));
                CSpinEdit1.Value =  random.Next(1, 9);
                CSpinEdit2.Value = random.Next(1, 9);

                btnTauschZ_Click(sender, e);

                CSpinEdit1.Value = random.Next(1, 9); 
                CSpinEdit2.Value = random.Next(1, 9); 
                btnTauschSp_Click(sender, e);
                if (random.Next(1, 10) == 5) btnTranspon_Click(sender,e);
                //if (CBMix.Checked) ;//permute(random(9) + 1, random(9) + 1);
            }
        }
        void copySG2global()
        {  // kopiert StringGrid1 / 4 in globales int-Array SG1 / 4
            // zwecks schnellerem Ablauf
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    SG1[i, j] = Convert.ToInt32(dataGridView1.Rows[i].Cells[j].Value);
                    SG4[i, j] = Convert.ToInt32(dataGridView4.Rows[i].Cells[j].Value);
                }
        }
        void copyglobal2SG()
        {  // kopiert globales int array SG1 / 4 zurück nach Stringgrid1 / 4
            // zwecks schnellerem Ablauf
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    dataGridView1.Rows[i].Cells[j].Value = SG1[i,j];
                    dataGridView4.Rows[i].Cells[j].Value = SG4[i,j];
                }


        }
        
        public int Str2NString(string txt, ref string[] val, char sep, bool IgnoreMultSep)
        {// separator defined with RadioButtons in this Form
            // separates the input string txt into any number of substrings separated with separator 
            // output string array is val. Returns the number of strings, which are found
            //char sep = getSeparator();
            // if IgnoreMultSep is true, multiple separators are ignored, otherwise they create empty output strings
            string sepstr = sep.ToString();
            int startx = 0, chnb, cnt = 0;
            int px = 0;
            if (txt.Length > 2)
            {// Minimum Lengh is 3 char
                if (IgnoreMultSep)
                {
                    while (txt.Substring(px, 1) == sepstr) px++; //skip leading seps
                    startx = px;

                    while ((px >= 0) && (px < txt.Length - 1))  // search for all separators
                    {
                        px = txt.IndexOf(sep, px + 1);
                        chnb = px - startx;
                        while ((px > -1) && (px < txt.Length - 1) && (txt.Substring(px + 1, 1) == sepstr)) px++; // if more than one sep skip

                        if ((px < txt.Length) && (px >= 0))
                        {

                            val[cnt] = txt.Substring(startx, chnb);
                            cnt++;

                            startx = px + 1;
                        }
                    }
                    if ((startx != txt.Length) && (px < 0)) // No sep at the end
                    {
                        val[cnt] = txt.Substring(startx, txt.Length - startx);
                        cnt++;
                    }
                }
                else  // Multiple separators creates empty strings
                {
                    while ((px >= 0) && (px < txt.Length))  // search for all separators
                    {
                        px = txt.IndexOf(sep, px);
                        chnb = px - startx;
                        if ((px < txt.Length) && (px >= 0))
                        {
                            if (chnb > 0)
                                val[cnt] = txt.Substring(startx, chnb);
                            else
                                val[cnt] = "";
                            cnt++;
                            px++;
                            startx = px;
                        }
                    }
                    if ((startx != txt.Length) && (px < 0)) // No sep at the end
                    {
                        val[cnt] = txt.Substring(startx, txt.Length - startx);
                        cnt++;
                    }

                }

            }

            else return (-1);
            return (cnt);
        }
        private void DBClear()
        {
            //for (int n = 0; n < dataGridViewDB.RowCount; n++)
                
                {
                    dataGridViewDB.Rows.Clear();
                }
        }
        private void checkDB()
        {
            string a;
            for (int n = 0; n < dataGridViewDB.RowCount - 1; n++)
            {
                for (int i = 0; i < 9; i++)
                {
                    a = dataGridViewDB.Rows[n].Cells[2 + i].Value.ToString();
                    if (a.Length < 9) for (int k = 0; k < ((9 + k) - (a.Length)); k++) //add more space 
                        {
                            a = a + " ";

                        }
                    dataGridViewDB.Rows[n].Cells[2 + i].Value = a;
                }
            }
        }
        private void btnLoadDB_Click(object sender, EventArgs e)
        {
            if (openFileDialog3.ShowDialog() == DialogResult.OK)
            {
                DBClear();
                labfehler.Visible = false;
                labzsp.Visible = false;
                Memo1.Clear();
                
                StreamReader myStream = new StreamReader(openFileDialog3.FileName, Encoding.Default);
                Memo1.Text = myStream.ReadToEnd();
                dataGridViewDB.Rows.Add(Memo1.Lines.Length);
                for (int n = 0; n < Memo1.Lines.Length; n++)
                {
                    char sep = ';';
                    string[] outstr = new string[22];
                    string a = Memo1.Lines[n];
                    //string a = textBox1.Text; 
                    int cnt = Str2NString(a, ref outstr, sep,false);
                    for (int i = 0; i < 22; i++)
                    {
                        dataGridViewDB.Rows[n].Cells[i].Value = outstr[i];
                    }
                    
                }
                checkDB();
                myStream.Close();
            }
        }
        private void CompareDB()
        {
            int cnt =0;
            int lastrow = dataGridViewDB.RowCount - 1;
            int u=0;
            for (int i = 0; i < dataGridViewDB.RowCount - 1; i++)
            {
                cnt = 0;
                for (int j = 0; j < 9; j++)
                {
                   
                    if (dataGridViewDB.Rows[i].Cells[2 + j].Value.ToString() ==
                        dataGridViewDB.Rows[lastrow].Cells[2 + j].Value.ToString())
                        cnt++;
                }
            
                if (cnt == 9)
                {
                    dataGridViewDB.Rows.RemoveAt(lastrow);
                    i = dataGridViewDB.RowCount;
                }
               // else u++;

            }
          
        }
        private void btnLoadAddDB_Click(object sender, EventArgs e)
        {
            if (openFileDialog2.ShowDialog() == DialogResult.OK)
            {

                StreamReader myStream = new StreamReader(openFileDialog2.FileName, Encoding.Default);
                textBox2.Text = myStream.ReadToEnd();

                //int u = 0;
                for (int n = 0; n < textBox2.Lines.Length; n++)
                {
                    dataGridViewDB.Rows.Add(1);
                    int lastrow = dataGridViewDB.RowCount-1;
                    char sep = ';';
                    string[] outstr = new string[22];
                    string a = textBox2.Lines[n];
                    int cnt = Str2NString(a, ref outstr, sep, false);
                    
                    for (int i = 0; i < 22; i++)
                    {
                        dataGridViewDB.Rows[lastrow].Cells[i].Value = outstr[i];
                            
                    }
                    CompareDB();
                } myStream.Close();
                
            }
        }

        private void btnSaveDB_Click(object sender, EventArgs e)
        {
            if (saveFileDialog2.ShowDialog() == DialogResult.OK)
            {
                Memo1.Clear();
                List<string> add = new List<string>();
                string a = ";";
                string b,c;


                for (int i = 0; i < dataGridViewDB.RowCount; i++)
                {
                    c = "";
                    for (int j = 0; j < dataGridViewDB.ColumnCount; j++)
                    {
                        if (dataGridViewDB.Rows[i].Cells[j].Value != null)
                        {
                            b = dataGridViewDB.Rows[i].Cells[j].Value.ToString();
                            c = c + b + a;
                        }
                    }
                    add.Add(c);
                    Memo1.Lines = add.ToArray();

                    StreamWriter myStream1 = new
                            StreamWriter(saveFileDialog2.OpenFile(), Encoding.Default);
                    myStream1.WriteLine(Memo1.Text);
                    myStream1.Close();
                }
              }
        }

       
        bool CheckDB(object sender, EventArgs e)
        {
            btnCheck_Click(sender, e); // Test ob Sudoku für DB OK.
            if (labzsp.Visible)     // Wenn OK, dann weiter
                return (false);
            // zähle Zahlen in linkem Sudoku, wenn nicht 81, dann nicht in DB
            int cnt = 0;
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (dataGridView1.Rows[i].Cells[j].Value.ToString().Length == 1) cnt++;
                }
            if (cnt != 81) { MessageBox.Show("left Sudoku must be solved"); return (false); }

            // zähle Zahlen in rechtem Sudoku, wenn nicht >16, dann nicht in DB
            cnt = 0;
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (dataGridView3.Rows[i].Cells[j].Value.ToString().Length == 1) cnt++;
                }
            if (cnt < 16) { MessageBox.Show("right Sudoku must have> 16 elements"); return (false); }

            // Vergleiche rechtes mit linkes Sudoku, wenn nicht identisch, dann nicht in DB
            //cnt = 0;
            //for (int i = 0; i < 9; i++)
            //    for (int j = 0; j < 9; j++)
            //    {
            //        if (dataGridView3.Rows[i].Cells[j].Value.ToString().Length == 1)
            //            if (dataGridView3.Rows[i].Cells[j].Value != dataGridView1.Rows[i].Cells[j].Value) cnt++;
            //    }
            //if (cnt > 0) { MessageBox.Show("rechtes Sudoku muss zu linkem passen"); return (false); }
            return (true);
        }
        

        private void clean()
        {
            dataGridView1.Visible = false;
            dataGridView1.Visible = true;
            //dataGridView2.Visible = false;
            //dataGridView2.Visible = true;
            //dataGridView3.Visible = false;
            //dataGridView3.Visible = true;
        }

        private void btnSDK2DB_Click(object sender, EventArgs e)
        {
            List<string> add = new List<string>();
            String a = "", b;
            int i, j;
            
            btnClean_Click(sender, e);
            add.Add(label1.Text);
            add.Add(label15.Text);
            if (CheckDB(sender, e))
            {
                for (i = 0; i < 9; i++)
                {
                    a = "";
                    for (j = 0; j < 9; j++)
                    {
                        b = dataGridView3.Rows[i].Cells[j].Value.ToString();
                        if (b == "") a = a + " "; else a = a + b;
                    }
                    add.Add(a);
                    // dataGridViewDB.Rows.Add(add);
                }
                for (i = 0; i < 9; i++)
                {
                    a = "";
                    for (j = 0; j < 9; j++)
                    {
                        b = dataGridView1.Rows[i].Cells[j].Value.ToString();
                        if (b == "") a = a + " "; else a = a + b;
                    }

                    add.Add(a);

                }
                add.Add("");
                add.Add(label3.Text);
                dataGridViewDB.Rows.Add(add.ToArray());
                CompareDB();
            }
        }

        private void btnDB2SDK_Click(object sender, EventArgs e)
        {
            label3.Visible = true;
            int i, j;
            string a, b;
            label1.Text = dataGridViewDB.CurrentRow.Cells[0].Value.ToString();
            label15.Text = dataGridViewDB.CurrentRow.Cells[1].Value.ToString();
            label3.Text = dataGridViewDB.CurrentRow.Cells[21].Value.ToString();

            for (i = 0; i < 9; i++)
            {
                a = dataGridViewDB.CurrentRow.Cells[2 + i].Value.ToString();
                if (a.Length < 9) for (int k = 0; k < ((9 + k) - (a.Length)); k++) //add more space 
                    {
                        a = a + " ";

                    }
                for (j = 0; j < 9; j++)
                {
                    b = a.Substring(j, 1);
                    if (b == " ") b = "";
                    dataGridView1.Rows[i].Cells[j].Value = b;
                }
            }
            btnCopyr_Click(sender, e);
            btnCopyd_Click(sender, e);
        }
        int checklvl()
        {
            bool N1Mlsg;
            int lsgcnt = 0;
            int mw = 0;
            int lsg = 0;
            int mwcnt;
            do
            {
                do    // 2. Strategie iterativ benutzen
                {
                    erg = Taste1Solver(); // Suche freie Zahlen
                    if (erg == 1) listBox5.Items.Add("level = easy"); return (1); // Sudoku gelöst
                    if (erg == 2) return (2); // Sudoku Widerspruch
                    N1Mlsg = CheckObEineLsg(ref lsgcnt);  // wenn true, hat Suche eine neue Zahl gefunden.
                }
                while (N1Mlsg); listBox5.Items.Add("level = m1");
                mwcnt = 0;  // Hier wird gezählt, ob Möglichkeiten reduziert wurden
                do
                {        // wende Paartrick an. Wenn Zahl gefunden, von oben neu anfangen
                    // wenn Möglichkeit weg, nochmal Paartrick
                    Paartrick(ref mw, ref lsg);
                    mwcnt = mwcnt + mw;
                    if ((mwcnt > 0) && (lsg == 0)) N1Mlsg = CheckObEineLsg(ref lsg);
                }
                while (lsg == 0); listBox5.Items.Add("level = m2");
                do
                {        // wende Austrick an. Wenn Zahl gefunden, von oben neu anfangen
                    // wenn Möglichkeit weg, nochmal Austrick
                    Austrick(ref mw, ref lsg);
                    mwcnt = mwcnt + mw;
                    if ((mwcnt > 0) && (lsg == 0)) N1Mlsg = CheckObEineLsg(ref lsg);
                }
                while ((mw != 0) && (lsg == 0)); listBox5.Items.Add("level = m3");
                

            }
            while ((CBneu.Checked) && (lsg > 0));
            return (0);  //Noch nicht fertig
        }
        private void btnChecklvl_Click(object sender, EventArgs e)
        {
            checklvl();
        }

        private void dataGridViewDB_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            btnDB2SDK_Click(sender, e);
        }
        int permute(int zahl, int zahlneu)
        {  // Parameter von 1 bis 9 möglich
            int inhalt, i, j;
            String s;
            if ((zahl < 1) | (zahl > 9) | (zahlneu < 1) | (zahlneu > 9))
                return (1);
            if (zahl != zahlneu)
                for (i = 0; i < 9; i++)  // Vertausche alle Plätze zahl <--> zahlneu
                    for (j = 0; j < 9; j++)
                    {
                        s = dataGridView1.Rows[i].Cells[j].Value.ToString();
                        if (s != "")
                        {
                            inhalt = Convert.ToInt32(s);
                            if (inhalt == zahl) dataGridView1.Rows[i].Cells[j].Value = zahlneu;
                            if (inhalt == zahlneu) dataGridView1.Rows[i].Cells[j].Value = zahl;
                        }
                        s = dataGridView3.Rows[i].Cells[j].Value.ToString();
                        if (s != "")
                        {
                            inhalt = Convert.ToInt32(s);
                            if (inhalt == zahl) dataGridView3.Rows[i].Cells[j].Value = zahlneu;
                            if (inhalt == zahlneu) dataGridView3.Rows[i].Cells[j].Value = zahl;
                        }
                    }
            return(0);
        }
        int permute1(int zahl, int zahlneu)
        {  // Parameter von 1 bis 9 möglich
            // Schnelle Version zum Suchen, arbeitet nur mit global Array
            int inhalt, i, j;
            if ((zahl < 1) | (zahl > 9) | (zahlneu < 1) | (zahlneu > 9))
                return (1);

            if (zahl != zahlneu)
            {
                for (i = 0; i < 9; i++)  // Vertausche alle Plätze zahl <--> zahlneu
                    for (j = 0; j < 9; j++)
                    {
                        inhalt = SG1[i,j];
                        if (inhalt == zahl) SG1[i,j] = zahlneu;
                        if (inhalt == zahlneu) SG1[i,j] = zahl;
                    }
            }
            return(0);
        }
        private void btnPermut_Click(object sender, EventArgs e)
        {
            permute(Convert.ToInt32( CSpinEdit5.Value),Convert.ToInt32( CSpinEdit6.Value));  // Zahlenpermutation in StringGrid1 und 3
        }

        private void btnCopyup_Click(object sender, EventArgs e)
        {
            labfehler.Visible = false;
            labzsp.Visible = false;
            
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    dataGridView1.Rows[i].Cells[j].Value = dataGridView4.Rows[i].Cells[j].Value;
                }

            label1.Text = label5.Text;
        }

        private void dataGridView4_Paint(object sender, PaintEventArgs e)
        {
            Pen p = new Pen(Color.Black, 2);
            Point poi1 = new Point(0, 92);
            Point poi2 = new Point(556, 92);
            e.Graphics.DrawLine(p, poi1, poi2);
            Point poi3 = new Point(0, 183);
            Point poi4 = new Point(556, 183);
            e.Graphics.DrawLine(p, poi3, poi4);
            Point poi5 = new Point(182, 0);
            Point poi6 = new Point(182, 278);
            e.Graphics.DrawLine(p, poi5, poi6);
            Point poi7 = new Point(361, 0);
            Point poi8 = new Point(361, 278);
            e.Graphics.DrawLine(p, poi7, poi8);
        }

        private void btnComp_Click(object sender, EventArgs e)
        {
            listBox2.Items.Clear();
             // alle roten Rechtecke löschen
            //for (int i = 0; i < 9; i++)
            //    for (int j = 0; j < 9; j++)
            //    {
            //        var rec = dataGridView4.GetCellDisplayRectangle(j, i, false);
            //        Graphics data4 = Graphics.FromHwnd(dataGridView4.Handle);
            //        Pen pen1 = new Pen(Color.White, 1);
            //        data4.DrawRectangle(pen1, rec);
            //    }
            
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (dataGridView4.Rows[i].Cells[j].Value != dataGridView1.Rows[i].Cells[j].Value)
                    {
                        var rec = dataGridView4.GetCellDisplayRectangle(j, i, false);
                        Graphics data4 = Graphics.FromHwnd(dataGridView4.Handle);
                        Pen pen1 = new Pen(Color.Red, 1);
                        data4.DrawRectangle(pen1, rec);
                    }
                }
        }
        int sucheblock(int b, int a, ref int posz,ref int poss,ref bool transp)
        {  // Vergleicht in StringGrid1  Block b mit dem Block Nr. a von
            // StringGrid4 passt, unabhängig von Transp, Spalte / Zeile
            // Nummer des Blockes durchnummeriert 1 2 3
            //                                    4 5 6
            //                                    7 8 9
            // Bei Rückgabe 0 passt nicht, bei 1 passt, bei 10 Fehler

            //Hole Inhalt von Block a  in SG
            int BZ=(a-1)/3;  //Blockzeile von 0 bis 2
            int BS=(a-1)-BZ*3;  // Blockspalte von 0 bis 2
            int zahlOL=SG4[BS*3,BZ*3];
            int zahlZ1=SG4[BS*3+1,BZ*3]; // gleiche Zeile
            int zahlZ2=SG4[BS*3+2,BZ*3];
            int zahlS1=SG4[BS*3,BZ*3+1]; // gleiche spalte
            int zahlS2=SG4[BS*3,BZ*3+2];
            int zahlN1=SG4[BS*3+1,BZ*3+1]; // restfeld
            int zahlN2=SG4[BS*3+2,BZ*3+1];

            int BZb,BSb,zz,ss;
            int [] z = new int [2];
            int [] s = new int [2];
            int z1,s1;
            bool kreuzOK=false;
            transp = false;  // init
            // Vergleich startet
            if ((b > 9) | (b < 1) | (a < 1) | (a > 9)) return (10);
            BZb = (b - 1) / 3;  //Blockzeile von 0 bis 2
            BSb = (b - 1) - BZb * 3;  // Blockspalte von 0 bis 2
            for (zz = 0; zz < 3; zz++)  // Suche Position von zahlOL im Suchblock
                for (ss = 0; ss < 3; ss++)
                { //Suche zahlOL in Block
                    if (zahlOL == SG1[ss + BSb * 3,zz + BZb * 3])
                    {
                        posz = zz; poss = ss; zz = 3; ss = 3; // Merke Stelle
                    }
                }
            z1 = 0; s1 = 0;
            for (int i = 0; i < 3; i++)  //Hole Kreuzzahlen
            {
                if (i != poss)
                {
                    z[z1] = SG1[i + BSb * 3,posz + BZb * 3];
                    z1++;
                }
                if (i != posz)
                {
                    s[s1] = SG1[poss + BSb * 3,i + BZb * 3];
                    s1++;
                }

            }
            if ((zahlZ1 != z[0]) & (zahlZ1 != z[1]) & (zahlZ1 != s[0]) & (zahlZ1 != s[1])) return (0);

            if (zahlZ1 == z[0])  // Check 1. Möglichkeit
            {
                if (zahlZ2 != z[1]) return (0);
                // ab hier stimmt schon mal eine Zeile
                if ((zahlS1 != s[0]) & (zahlS1 != s[1])) return (0);
                if (zahlS1 == s[0])
                {
                    if (zahlS2 != s[1]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                }
                else
                { // also ist zahlS1==s[1]
                    if (zahlS2 != s[0]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                }

            }
            if (zahlZ1 == z[1])  // Check 2. Möglichkeit
            {
                if (zahlZ2 != z[0]) return (0);
                // ab hier stimmt schon mal eine Zeile
                if ((zahlS1 != s[0]) & (zahlS1 != s[1])) return (0);
                if (zahlS1 == s[0])
                {
                    if (zahlS2 != s[1]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                }
                else
                { // also ist zahlS1==s[1]
                    if (zahlS2 != s[0]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                }

            }
            if (zahlZ1 == s[0])  // Check 3. Möglichkeit
            {
                if (zahlZ2 != s[1]) return (0);
                // ab hier stimmt schon mal eine Spalte
                if ((zahlS1 != z[0]) & (zahlS1 != z[1])) return (0);
                if (zahlS1 == z[0])
                {
                    if (zahlS2 != z[1]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                    transp = true;
                }
                else
                { // also ist zahlS1==z[1]
                    if (zahlS2 != z[0]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                    transp = true;
                }

            }

            if (zahlZ1 == s[1])  // Check 4. Möglichkeit
            {
                if (zahlZ2 != s[0]) return (0);
                // ab hier stimmt schon mal eine Spalte
                if ((zahlS1 != z[0]) & (zahlS1 != z[1])) return (0);
                if (zahlS1 == z[0])
                {
                    if (zahlS2 != z[1]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                    transp = true;
                }
                else
                { // also ist zahlS1==z[1]
                    if (zahlS2 != z[0]) return (0);
                    // Hier stimmt das Kreuz
                    kreuzOK = true;
                    transp = true;
                }

            }
            if (kreuzOK) return (1);
            else return (0);// jetzt 3*3 mit tauschen auf original bringen
            // check letzten vier Werte.

        }

        private void btnSuche_Click(object sender, EventArgs e)
        {
            int ergz=0;
            int ergs=0;
            int erg =0;
            int cnt=0;
                
            bool trans =false;
           // List<string> aus = new List<string>();
            String aus;
            listBox2.Items.Clear();
            int cnt2 = 0;
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (dataGridView1.Rows[i].Cells[j].Value.ToString().Length  == 1) cnt2++;
                }
            int cnt1 = 0;
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (dataGridView4.Rows[i].Cells[j].Value.ToString().Length == 1) cnt1++;
                }
            if ((cnt2 != 81) || (cnt1 != 81)) MessageBox.Show("upper and left Sudoku must be solved");
            else
            {

                copySG2global();
                for (int a = 1; a < 10; a++)  //klapper alle 9 Blocks in SG4 ab
                {
                    for (int b = 1; b < 10; b++) //klapper alle 9 Blocks in SG1 ab
                    {
                        aus = Convert.ToString(a) + " --> ";
                        erg = sucheblock(b, a,ref ergz,ref ergs,ref trans);
                        if (erg == 1)
                        {
                            aus = aus + Convert.ToString(b);
                            if (trans) aus = aus + " trans";
                            cnt++; // Zähle gefundene 3*3 Blöcke
                            b = 10; //Verlasse Schleife;
                        }
                        else
                        {
                            aus = aus + "   not";
                        }
                    listBox2.Items.Add(aus);
                    }
                   
                      
                }
                
                copyglobal2SG();
            } // end else

        }
        int compareSG1SG4()
        { // Vergleicht Sudoku in SG1 mit SG4. Wenn alle 9 Sterne pro 3*3 passen, dann sollte Rückgabe =9 sein.
            // Wenn Rückgabe kleiner, dann sind es verschiedene Sudoku, die nicht durch Z / Sp Blockvertauschung
            // entstanden sind. Keine Zahlenpermutation

            int ergz = 0;
            int ergs = 0;
            int erg = 0;
            int cnt = 0;
            bool trans=false;
            for (int a = 1; a < 10; a++)  //klapper alle 9 Blocks in SG4 ab
            {
                for (int b = 1; b < 10; b++) //klapper alle 9 Blocks in SG1 ab
                {
                    erg = sucheblock(b, a,ref ergz,ref ergs,ref trans);
                    if (erg == 1)
                    {
                        cnt++; // Zähle gefundene 3*3 Blöcke
                        b = 10; //Verlasse innere Schleife;
                    }
                    if (erg == 10) MessageBox.Show("Error in compareSG1SG4");
                }
            }
            return (cnt);
        }
        //int compmitpermut(ref int max)
        //{  // Es werden sämtliche 9! = 362880 Zahlenpermutationen durchgeführt und die Sudokus verglichen
        //    // Wenn Rückgabe = 362880, dann sind Sudokus nicht durch Z / Sp / B- Vertauschung Incl. Permutation
        //    // entstanden und damit verschieden.

        //int cnt=0,erg,zahl1,zahl2;
        //int a,b,c,d,e,f,g,i;
        //int []aa=new int [9];
        //int []bb=new int [8];
        //int []cc=new int [7];
        //int []dd=new int [6];
        //int []ee=new int [5];
        //int []ff=new int [4];
        //int []gg=new int [3];
            

        //max=0;
        //for(i=0;i<9;i++) aa[i]=SG1[i,0];
        //for(a=0;a<9;a++)
        //{
        //for (i=0;i<8;i++) bb[i]=SG1[1+i,0];
        //for (b=0;b<8;b++)
        //{
        //    for (i=0;i<7;i++) cc[i]=SG1[2+i,0];
        //    for (c=0;c<7;c++)
        //    {
        //    for (i=0;i<6;i++) dd[i]=SG1[3+i,0];
        //    for (d=0;d<6;d++)
        //    {
        //    for (i=0;i<5;i++) ee[i]=SG1[4+i,0];
        //    for (e=0;e<5;e++)
        //    {
        //    for (i=0;i<4;i++) ff[i]=SG1[5+i,0];
        //    for (f=0;f<4;f++)
        //    {
        //        gg[0]=SG1[6,0];
        //        gg[1]=SG1[7,0];
        //        gg[2]=SG1[8,0];
        //        for (g=0;g<3;g++)
        //        {
        //        erg=compareSG1SG4();
        //        if (erg>max) max=erg;
        //        cnt++;
        //        if (erg==9) return (cnt);
        //        zahl1=SG1[8,0];
        //        zahl2=SG1[7,0];
        //        permute1(zahl1,zahl2);
        //        erg=compareSG1SG4();
        //        if (erg>max) max=erg;
        //        cnt++;
        //        if (erg==9) return (cnt);
        //        if (g<2)permute1(gg[g],gg[g+1]);
        //        }
        //        if (f<3)permute1(ff[f],ff[f+1]);
        //    }
        //    if (e<4)permute1(ee[e],ee[e+1]);
        //    }
        //    if (d<5)permute1(dd[d],dd[d+1]);
        //    }
        //    if (c<6)permute1(cc[c],cc[c+1]);
        //    }
        //    if (b<7)permute1(bb[b],bb[b+1]);
        //}
        //if (a<8)permute1(aa[a],aa[a+1]);
        //}


        //return(cnt);
        //}
        //double Dauer = -1;

        private void btnMark_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 9; i++)
                for (int j = 0; j < 9; j++)
                {
                    if (dataGridView1.Rows[i].Cells[j].Value != dataGridView6.Rows[i].Cells[j].Value)
                    {
                        var rec = dataGridView6.GetCellDisplayRectangle(j, i, false);
                        Graphics data6 = Graphics.FromHwnd(dataGridView6.Handle);
                        Pen pen1 = new Pen(Color.Red, 1);
                        data6.DrawRectangle(pen1, rec);
                    }
                }
        } 
    }
}
